C+    compare_parameter_range.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM COMPARES THE RANGES OF CONTROL PARAMETER
C+    AND WAVE SPEED VALUES GIVEN IN THE TWO FILES
C+    ../temp_files/parameter_range.input.rcodes AND
C+    ../temp_files/parameter_range.input.pcode.
C+    A FORTRAN PROGRAM IS NEEDED FOR THIS BECAUSE EVEN IF THE
C+    NUMERICAL VALUES ARE THE SAME, THEY MAY HAVE A DIFFERENT
C+    FORMAT IN TWO FILES
C++
      OPEN(11,FILE='../temp_files/parameter_range.input.rcodes'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)PPMIN1,PPMAX1
      READ(11,*)CMIN1,CMAX1
      CLOSE(11)
      OPEN(12,FILE='../temp_files/parameter_range.input.pcode'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)PPMIN2,PPMAX2
      READ(12,*)CMIN2,CMAX2
      CLOSE(12)
      PPGAP1=0.001D0*ABS(PPMAX1-PPMIN1)
      CGAP1=0.001D0*ABS(CMAX1-CMIN1)
      PPGAP2=0.001D0*ABS(PPMAX2-PPMIN2)
      CGAP2=0.001D0*ABS(CMAX2-CMIN2)
      PPGAP=MIN(PPGAP1,PPGAP2)
      CGAP=MIN(CGAP1,CGAP2)
C     NOTE THAT THE CHOICE OF 0.1% OF THE VARIATION
C          AS A THRESHOLD IS ARBITRARY.
      IANS=0
      IF ((ABS(PPMIN2-PPMIN1)).GT.PPGAP) THEN
         IANS=1
      ENDIF
      IF ((ABS(PPMAX2-PPMAX1)).GT.PPGAP) THEN
         IANS=1
      ENDIF
      IF ((ABS(CMIN2-CMIN1)).GT.CGAP) THEN
         IANS=1
      ENDIF
      IF ((ABS(CMAX2-CMAX1)).GT.CGAP) THEN
         IANS=1
      ENDIF
C     NOW WRITE OUTPUT
      OPEN(13,FILE=
     &     '../temp_files/compare_parameter_range.output'
     &,STATUS='NEW')
      WRITE(13,'(I1)')IANS
      CLOSE(13)
      STOP
      END
