C+    extractboundary.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE AUTO OUTPUT FILES FROM A RUN
C+    CALCULATING A STABILITY BOUNDARY CURVE, AND REWRITES IT IN
C+    A MORE USER-FRIENDLY FORM.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      DIMENSION DARRAY(6)
      CALL GINFO(INFO)
      PI=ACOS(-1.0D0)
      ZERO=0.0D0
      IZERO=0
      OPEN(11,FILE='data_files/extractboundary.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)IBTYPE
      CLOSE(11)
C     IBTYPE=1 FOR ECKHAUS, 2 FOR HOPF
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
      OPEN(12,FILE='p.boundarydata'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='data_files/boundary.boundarydata'
     &,STATUS='NEW')
      WRITE(13,9000)ZERO,ZERO,IZERO,ZERO
      OPEN(14,FILE='data_files/newcrossings.data',STATUS='NEW')
C-----
      IARRAY=2
C     The significance of iarray is that in the "p." output file, 
C       auto prints the norm, max U(1), and the other 5 
C       continuation parameters after pp (icp1). Since c is icp2, 
C       the norm and max U(1) appear in between pp and c. There
C       are then three other parameters before the period, which
C       is icp6.
      DO 200 J=1,12
         READ(12,*)IDUMMY
 200  CONTINUE
      DO 210 J=1,NMXSB+1
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,
     &        PP,(DARRAY(I),I=1,IARRAY),C,
     &        (DARRAY(I),I=3,5),PERIOD
         WRITE(13,9000)PP,C,IBTYPE,PERIOD
         IF (ITY.EQ.(-4)) THEN
            WRITE(14,9100)PP,C
         ENDIF
         IF (J.EQ.NMXSB) THEN
            OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
            REWIND(66)
            WRITE(66,'('' '')')
            WRITE(66,'(''WARNING: MAX NUMBER OF STEPS WAS REACHED'')')
            WRITE(66,'(''   WHILE TRACKING THE STABILITY BOUNDARY'')')
            CLOSE(66)
            CALL IOUT(INFO,'errsf')
         ENDIF
 210  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      WRITE(66,'(''ERROR: LOOP 210 FINISHED in extractboundary.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
      CALL ISTOP(INFO)
 9000 FORMAT(2E18.10E2,I2,E18.10E2)
 9100 FORMAT('PARAMETER=',E17.10E2,' WAVESPEED=',E17.10E2,
     &' lies on the stability bdy')
C     Note: the words "PARAMETER" and "WAVESPEED" are replaced
C           by the appropriate symbols in the script
C           controller/stabilityboundary.script
      END
