C+    extractcontour.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE AUTO OUTPUT FILES FROM A RUN
C+    CALCULATING A LOCUS OF CONSTANT WAVE PERIOD, AND REWRITES 
C+    IT IN A MORE USER-FRIENDLY FORM.
C+    THE PROGRAM ALSO EXTRACTS PERIODIC TRAVELLING WAVE 
C+    SOLUTIONS FOR POINTS AT WHICH THE LOCUS CROSSES CONTROL 
C+    PARAMETER OR WAVE SPEED VALUES SPECIFIED IN THE OPTIONAL
C+    ARGUMENTS TO THE period_contour COMMAND (IF ANY).
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER (MAXLBL=100)
      PARAMETER (NPTW=REST OF LINE IS REPLACED IN CALLING SCRIPT
      LOGICAL NFIRST,REPEAT
      CHARACTER*2 AFILE(99)
      DIMENSION DARRAY(6),JARRAY(9),PARRAY(7)
      DIMENSION PPLBL(MAXLBL),CLABEL(MAXLBL),
     &     IOLBL(MAXLBL)
      DIMENSION U(NPTW)
      DATA AFILE/
     &     '01','02','03','04','05','06','07','08','09',
     &'10','11','12','13','14','15','16','17','18','19',
     &'20','21','22','23','24','25','26','27','28','29',
     &'30','31','32','33','34','35','36','37','38','39',
     &'40','41','42','43','44','45','46','47','48','49',
     &'50','51','52','53','54','55','56','57','58','59',
     &'60','61','62','63','64','65','66','67','68','69',
     &'70','71','72','73','74','75','76','77','78','79',
     &'80','81','82','83','84','85','86','87','88','89',
     &'90','91','92','93','94','95','96','97','98','99'/
      CALL GINFO(INFO)
      ZERO=0.0D0
      IZERO=0
      IONE=1
      OPEN(16,FILE='../temp_files/valueofperiod.data'
     &,STATUS='OLD')
      REWIND(16)
      READ(16,*)PERIOD
      CLOSE(16)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
      OPEN(15,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)PPMIN,PPMAX
      READ(15,*)CMIN,CMAX
      CLOSE(15)
      OPEN(12,FILE='p.contourdata'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='../temp_files/contour.contourdata'
     &,STATUS='NEW')
      WRITE(13,9000)ZERO,ZERO,IZERO,ZERO
C-----
      OPEN(18,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(18)
      READ(18,*)NPDE
      READ(18,*)NPTW1
      CLOSE(18)
      IF (NPTW1.NE.NPTW) THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         REWIND(66)
         WRITE(66,'(''ERROR: DISCREPANCY BETWEEN NPTW AND'')')
         WRITE(66,'(''       NPTW1 in extractcontour.f'')')
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
      ENDIF
      IARRAY=MIN(6,NPTW+1) 
C     The significance of iarray is that in the "p." output file, 
C       auto prints the norm and up to 5 variable values between the
C       two continuation parameters.
      DO 200 J=1,12
         READ(12,*)IDUMMY
 200  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'('' '')')
      CLOSE(66)
C     The above writing to message.txt is a dummy, to ensure
C     that the file can be opened as "OLD" henceforth
      DO 210 J=1,NMXPTW+1
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,
     &        PP,(DARRAY(I),I=1,IARRAY),C
         WRITE(13,9000)PP,C,IONE,PERIOD
         IF (J.EQ.NMXPTW) THEN
            OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
            REWIND(66)
            WRITE(66,'('' '')')
            WRITE(66,'(''WARNING: MAX NUMBER OF STEPS WAS REACHED'')')
            WRITE(66,'(''       WHILE TRACKING THE PERIOD CONTOUR'')')
            CLOSE(66)
            CALL IOUT(INFO,'errsf')
         ENDIF
 210  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: LOOP 210 FINISHED in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      CLOSE(12)
      CLOSE(13)
C-----
C     Now read in existing labels (if any)
      OPEN(14,FILE='data_files/contour.labels'
     &,STATUS='OLD')
      REWIND(14)
C     INPUT FILE
      NLABEL=0
      DO 250 I=1,MAXLBL
         READ(14,*,END=251)PPLBL(I),CLABEL(I),IOLBL(I),PRDIN
         NLABEL=I
         IF (PRDIN.NE.PERIOD) THEN
            OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
            REWIND(66)
            WRITE(66,'(''ERROR: DISCREPANCY IN PERIODS'',
     &           '' in extractcontour.f'')')
            CLOSE(66)
            CALL IOUT(INFO,'error')
            CALL ISTOP(INFO)
         ENDIF
 250  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: LOOP 250 FINISHED in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 251  CLOSE(14)
C     Now check where contour crosses max/min values of pp and c
      ITOP=8
      IBOTTM=2
      ILEFT=4
      IRIGHT=6
      OPEN(13,FILE='../temp_files/contour.contourdata'
     &,STATUS='OLD')
      REWIND(13)
C     NOW AN INPUT FILE
      OPEN(19,FILE='data_files/contour.contourdata'
     &,STATUS='NEW')
      NFIRST=.FALSE.
      DO 300 I=1,NMXPTW+2
         READ(13,*,END=301)PP,C,I01
C         IF ((I01.EQ.0).OR.
C     &        ((PP.GE.PPMIN).AND.(PP.LE.PPMAX).AND.
C     &        (C.GE.CMIN).AND.(C.LE.CMAX))) THEN
            WRITE(19,9000)PP,C,I01,PERIOD
C         ENDIF
C         Note: the IF/ENDIF above was commented out when
C               I added the box around period contour labels.
C               As a result files 13 and 19 are always the 
C               same but I decided to leave the structure
C               with both files in case I decided to revert
C               to the previous approach for contour labelling.
         IF (NFIRST.AND.(I01.NE.0).AND.(I01OLD.NE.0)) THEN
            IF (((PP-PPMAX)*(PPOLD-PPMAX)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
                  REWIND(66)
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=PPMAX
               CLABEL(NLABEL)=(C+COLD)/2.0D0
               IOLBL(NLABEL)=IRIGHT
            ENDIF
            IF (((PP-PPMIN)*(PPOLD-PPMIN)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
                  REWIND(66)
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=PPMIN
               CLABEL(NLABEL)=(C+COLD)/2.0D0
               IOLBL(NLABEL)=ILEFT
            ENDIF
            IF (((C-CMAX)*(COLD-CMAX)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
                  REWIND(66)
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=(PP+PPOLD)/2.0D0
               CLABEL(NLABEL)=CMAX
               IOLBL(NLABEL)=ITOP
            ENDIF
            IF (((C-CMIN)*(COLD-CMIN)).LE.ZERO) THEN
               NLABEL=NLABEL+1
               IF (NLABEL.GT.MAXLBL) THEN
                  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
                  REWIND(66)
                  WRITE(66,'(''ERROR: maxlbl TOO SMALL'',
     &                 '' in extractcontour.f'')')
                  CLOSE(66)
                  CALL IOUT(INFO,'error')
                  CALL ISTOP(INFO)
               ENDIF
               PPLBL(NLABEL)=(PP+PPOLD)/2.0D0
               CLABEL(NLABEL)=CMIN
               IOLBL(NLABEL)=IBOTTM
            ENDIF
         ENDIF
         PPOLD=PP
         COLD=C
         I01OLD=I01
         NFIRST=.TRUE.
 300  CONTINUE
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: LOOP 300 FINISHED in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 301  CLOSE(13)
      CLOSE(19)
C     Now eliminate any label points that are (almost) duplicates or 
C       that are out of range. Use a tolerance of 1% (arbitrary) of 
C       the overall range on each axis (pp and c) to define labels 
C       as being duplicates, or being far enough outside the 
C       plotting region to be designated as out of range.
      PPTOL=(PPMAX-PPMIN)*0.01D0 
      CTOL=(CMAX-CMIN)*0.01D0
      OPEN(14,FILE='data_files/contour.labels'
     &,STATUS='OLD')
      REWIND(14)
C     NOW AN OUTPUT FILE
      DO 400 I=1,NLABEL
         REPEAT=.FALSE.
         DO 401 J=1,I-1
            IF ((ABS(PPLBL(I)-PPLBL(J)).LT.PPTOL).AND.
     &           (ABS(CLABEL(I)-CLABEL(J)).LT.CTOL).AND.
     &           (IOLBL(I).EQ.IOLBL(J))) THEN
               REPEAT=.TRUE.
            ENDIF
 401     CONTINUE
         IF ((.NOT.REPEAT).AND.
     &        (PPLBL(I).GT.(PPMIN-PPTOL)).AND.
     &        (PPLBL(I).LT.(PPMAX+PPTOL)).AND.
     &        (CLABEL(I).GT.(CMIN-CTOL)).AND.
     &        (CLABEL(I).LT.(CMAX+CTOL))) THEN
            WRITE(14,9100)PPLBL(I),CLABEL(I),IOLBL(I),PERIOD
         ENDIF
 400  CONTINUE
      CLOSE(14)
C     Now extract solutions for points at which the locus crosses
C     control parameter or wave speed values specified in the
C     optional arguments to the period_contour command (if any).
      OPEN(21,FILE='data_files/lastpcfile.dat'
     &,STATUS='OLD')
      REWIND(21)
      READ(21,*)ILAST
      CLOSE(21)
      OPEN(22,FILE='q.contourdata'
     &,STATUS='OLD')
      REWIND(22)
      OPEN(25,FILE='data_files/newpccrossings.data'
     &,STATUS='NEW')
      ISTART=ILAST+1
      DO 700 I=ISTART,99
C        Note that if there are more than 99 crossings, only
C          the first 99 are recorded.
         READ(22,*,END=710)(JARRAY(J),J=1,9)
C        Note that JARRAY(3) should be either -4 or 9 or poss -9
         IF (JARRAY(3).EQ.(-4)) THEN
            ILAST=ILAST+1
            OPEN(23,FILE='data_files/pcsolution'//AFILE(ILAST)//
     &           '.soln'
     &,STATUS='NEW')
            DO 701 ILOOP3=1,JARRAY(7)
               READ(22,*,END=702)Z,(U(J),J=1,NPTW)
               WRITE(23,9200)(PERIOD*Z),(U(J),J=1,NPTW)
 701        CONTINUE
            CLOSE(23)
            DO 703 ILOOP3=1,(JARRAY(7)+2)
               READ(22,*,END=702)
 703           CONTINUE
            READ(22,*,END=702)(PARRAY(J),J=1,7)
            OPEN(24,FILE='data_files/pcsolution'//AFILE(ILAST)//
     &           '.params'
     &,STATUS='NEW')
            WRITE(24,9300)PARRAY(1),PARRAY(2)
            CLOSE(24)
            WRITE(25,9400)AFILE(ILAST),PARRAY(1),PARRAY(2),PERIOD
            DO 704 ILOOP3=(2*JARRAY(7)+4),JARRAY(9)
               READ(22,*,END=702)
 704        CONTINUE
         ELSE
            DO 705 ILOOP3=1,JARRAY(9)
               READ(22,*,END=702)
 705        CONTINUE
         ENDIF
 700  CONTINUE
 710  CLOSE(22)
      CLOSE(25)
      OPEN(21,FILE='data_files/lastpcfile.dat'
     &,STATUS='OLD')
      REWIND(21)
      WRITE(21,9500)ILAST
      CLOSE(21)
      CALL ISTOP(INFO)
 702  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      WRITE(66,'(''ERROR: premature end of file 22'',
     &     '' in extractcontour.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(22)
      CLOSE(25)
      CALL ISTOP(INFO)
 9000 FORMAT(2E18.10E2,I2,'  hc 0',E18.10E2)
 9100 FORMAT(2E18.10E2,I2,E18.10E2,'  hc 0')
 9200 FORMAT(REST OF LINE IS REPLACED IN CALLING SCRIPT
 9300 FORMAT(2E18.10E2)
 9400 FORMAT('Code=',A2,'   PARAMETER=',E17.10E2,
     &'   WAVESPEED=',E17.10E2,'   period=',E17.10E2)
C     Note: the words "PARAMETER" and "WAVESPEED" are replaced
C           by the appropriate symbols in the script
C           controller/stabilityboundary.script
 9500 FORMAT(I8)
      END
