C+    hopf_prepare.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES FOR 
C+    THE CALCULATIONS OF STABILITY BOUNDARIES OF HOPF TYPE.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(15,FILE='../temp_files/sbdy_prepare.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)ICPIN,CPSTRT,CPEND
      CLOSE(15)
C-----
      OPEN(16,FILE='data_files/hopf.gstart'
     &,STATUS='OLD')
      READ(16,*)GEND
      CLOSE(16)
      OPEN(18,FILE='../temp_files/spectrum.grangemax'
     &,STATUS='OLD')
      REWIND(18)
      READ(18,*)GHMIN,GHMAX
      CLOSE(18)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
C     This is ntst3
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)DSIN,DSMNIN,DSMXIN
      CLOSE(12)
      DSIN=ABS(DSIN)
C      Just in case a -ve value was entered by mistake
C-----
      OPEN(13,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX
      READ(13,*)CMIN,CMAX
      CLOSE(13)
C-----
C      IF (ICPIN.EQ.1) THEN
         DSFCTR=1.0D0
C      ELSE
C         DSFCTR=(ABS(CMAX)+ABS(CMIN))/(ABS(PPMAX)+ABS(PPMIN))
C      ENDIF
C     Note: I decided to take out this rescaling since so many
C           different things are involved in the pseudo-arclength.
C-----
      DSRS=DSIN*DSFCTR
      DSMNRS=DSMNIN*DSFCTR
      DSMXRS=DSMXIN*DSFCTR
C     Note: the input ds values are for pp. Multiplying by dsfctr has
C           the effect of rescaling appropriately if continuation is
C           done with c as a continuation parameter and not pp.
C-----
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)IDUMY1,IDUMY2,IDUMY3,IDUMY4,NMXIN,NMXDUM
      READ(11,*)A0,A1
      READ(11,*)
      READ(11,*)EPSL,EPSU,EPSS
      CLOSE(11)
C-----
C     Write the first auto constants file: for continuation in a 
C     dummy parameter in order to get a starting solution for the
C     derivatives of the eigenfunction with respect to i*gamma
C-----
      NDIM=5*NPTW
      IPS=4
      IRS=1
C      The solution created by the @fc command is labelled 1
      ILP=0
      NICP=6
      ICP1=9
C      a dummy parameter
      ICP2=5
C      Re(e-value)
      ICP3=6
C      Im(e-value)
      ICP4=7
C      Real part of first derivative of e-value wrt i*gamma
C      This is equal to d(Im e-value)/d(gamma)
      ICP5=8
C      Imag part of first derivative of e-value wrt i*gamma
C      This is equal to -d(Re e-value)/d(gamma)
      ICP6=3
C      Period
C     Note: the fixed parameters are pp, c and gamma
      NCOL=4
      IAD=3
      ISP=0
      ISW=1
      IPLT=0
      NBC=5*NPTW
      NINT=5
      NMX=NMXDUM
C     A few steps only for this continuation in a dummy parameter
      RL0=-1.0D6
C      A large -ve value to prevent this limit being reached
      RL1=+1.0D6
C      A large +ve value to prevent this limit being reached
      MXBF=10
      IID=2
      ITMX=8
      ITNW=7
C      Incr from usual value of 5 (recommended for hard problems)
      NWTN=3
      JAC=0
      DS=0.01D0
C     Arbitrary: dummy parameter
      DSMIN=0.001D0
C     Arbitrary: dummy parameter
      DSMAX=0.1D0
C     Arbitrary: dummy parameter
      IADS=1
C-----
      OPEN(21,FILE='r.hopf'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,I8,I2)')NDIM,IPS,IRS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 100 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 100  CONTINUE
      WRITE(21,'('' 0 '')')
      CLOSE(21)
C-----
C     Write the second auto constants file: for checking the direction
C     of continuation along the spectrum, prior to searching for the 
C     fold in the spectrum.
C-----
      IRS=2
      ICP1=4
C     gamma
C     Note: the fixed parameters are pp and c
      RL0=GHMIN
      RL1=MAX(GHMAX,GEND)*1.1D0-0.1D0*GHMIN
C     Note that GEND may be greater than GHMAX because of an 
C     overshoot in the previous continuation using spectrum:
C     this is not a problem.
      NMX=NMXDUM
C     A few steps only, for checking continuation direction
      DS=-DSIN
      DSMIN=DSMNIN
      DSMAX=DSMXIN
C-----
      OPEN(21,FILE='r.hopf.2'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,I8,I2)')NDIM,IPS,IRS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E16.8E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 101 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 101  CONTINUE
      WRITE(21,'('' 0 '')')
      CLOSE(21)
C-----
C     Write the third auto constants file: to search for a
C     fold in the spectrum. Two versions are written, differing 
C     only in the sign of ds.
C-----
      NMX=NMXIN 
C-----
      OPEN(21,FILE='r.hopf.3samedirection'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,I8,I2)')NDIM,IPS,IRS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E16.8E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 102 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 102  CONTINUE
      WRITE(21,'('' 1 '',/,'' 8  0. '')')
C     A NOTE ABOUT THE METHODOLOGY: IN MANY OTHER AUTO RUNS THE OUTPUT
C       LABEL HAS BEEN SPECIFIED AS NEGATIVE SO THAT AUTO OUTPUTS WHEN
C       IT REACHES THE REQUIRED VALUE. THEN IT IS NECESSARY TO ASSESS
C       WHETHER OR NOT THE REQUIRED OUTPUT POINT HAS BEEN REACHED. FOR
C       INSTANCE, THE PARAMETERS periodatol AND periodrtol ARE USED FOR
C       THIS PURPOSE WHEN SEARCHING FOR A SOLUTION OF GIVEN PERIOD IN
C       THE periodcontour PROGRAMS. HOWEVER I COULD NOT SEE ANY WAY OF
C       ASSESSING A PRIORI A SUITABLE THRESHOLD FOR PAR(8) AND SO I HAVE
C       LEFT AUTO TO ASSESS WHEN IT BECOMES ZERO. THE DOWNSIDE OF THIS IS
C       THE EXTRA COMPUTATION TIME WHILE AUTO CONTINUES THE SOLUTION AFTER
C       PAR(8) HAS CHANGED SIGN, BUT THERE SEEMS NO WAY OF AVOIDING THIS.
      CLOSE(21)
C-----
      DS=-DS
C-----
      OPEN(21,FILE='r.hopf.3otherdirection'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,I8,I2)')NDIM,IPS,IRS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 103 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 103  CONTINUE
      WRITE(21,'('' 1 '',/,'' 8  0. '')')
C     A NOTE ABOUT THE METHODOLOGY: IN MANY OTHER AUTO RUNS THE OUTPUT
C       LABEL HAS BEEN SPECIFIED AS NEGATIVE SO THAT AUTO OUTPUTS WHEN
C       IT REACHES THE REQUIRED VALUE. THEN IT IS NECESSARY TO ASSESS
C       WHETHER OR NOT THE REQUIRED OUTPUT POINT HAS BEEN REACHED. FOR
C       INSTANCE, THE PARAMETERS periodatol AND periodrtol ARE USED FOR
C       THIS PURPOSE WHEN SEARCHING FOR A SOLUTION OF GIVEN PERIOD IN
C       THE periodcontour PROGRAMS. HOWEVER I COULD NOT SEE ANY WAY OF
C       ASSESSING A PRIORI A SUITABLE THRESHOLD FOR PAR(8) AND SO I HAVE
C       LEFT AUTO TO ASSESS WHEN IT BECOMES ZERO. THE DOWNSIDE OF THIS IS
C       THE EXTRA COMPUTATION TIME WHILE AUTO CONTINUES THE SOLUTION AFTER
C       PAR(8) HAS CHANGED SIGN, BUT THERE SEEMS NO WAY OF AVOIDING THIS.
      CLOSE(21)
C-----
C     Write the fourth auto constants file: for checking the direction
C     of continuation prior to tracking the fold as pp or c vary, 
C     searching for an Hopf point
C-----
      ICP1=ICPIN
      ICP5=4
C     Note: the fixed parameters are d(Re e-value)/d(gamma)
C           and pp or c (whichever one is not ICPIN)
      IF (CPSTRT.LT.CPEND) THEN
         RL0=CPSTRT-0.1D0*(CPEND-CPSTRT)
         RL1=CPEND
         ISIGN=1
      ELSE
         RL0=CPEND
         RL1=CPSTRT+0.1D0*(CPSTRT-CPEND)
         ISIGN=-1
      ENDIF
C     rl0 and rl1 are set in this way because continuation should
C     stop once the continuation parameter reaches its end value; 
C     10% (chosen arbitrarily) of the range is added to the start 
C     value in the opposite direction to the end value to provide
C     a suitable limit in case of an error of some kind -- this 
C     limit should never be reached.
      NMX=NMXDUM
C      A few steps only, for checking continuation direction
      DS=ISIGN*DSRS
      DSMIN=DSMNRS
      DSMAX=DSMXRS
C-----
      OPEN(21,FILE='r.hopf.4'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,'' IRS '',I2)')NDIM,IPS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 111 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 111  CONTINUE
      WRITE(21,'('' 0 '')')
      CLOSE(21)
C-----
C     Write the fifth auto constants file: to search for an
C     Hopf point. Two versions are written, differing only in
C     the sign of ds
C-----
      NMX=NMXIN 
C-----
      OPEN(21,FILE='r.hopf.5samedirection'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,'' IRS '',I2)')NDIM,IPS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 112 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 112  CONTINUE
      WRITE(21,'('' 1 '',/,'' 5  0. '')')
C     A NOTE ABOUT THE METHODOLOGY: IN MANY OTHER AUTO RUNS THE OUTPUT
C       LABEL HAS BEEN SPECIFIED AS NEGATIVE SO THAT AUTO OUTPUTS WHEN
C       IT REACHES THE REQUIRED VALUE. THEN IT IS NECESSARY TO ASSESS
C       WHETHER OR NOT THE REQUIRED OUTPUT POINT HAS BEEN REACHED. FOR
C       INSTANCE, THE PARAMETERS periodatol AND periodrtol ARE USED FOR
C       THIS PURPOSE WHEN SEARCHING FOR A SOLUTION OF GIVEN PERIOD IN
C       THE periodcontour PROGRAMS. HOWEVER I COULD NOT SEE ANY WAY OF
C       ASSESSING A PRIORI A SUITABLE THRESHOLD FOR PAR(5) AND SO I HAVE
C       LEFT AUTO TO ASSESS WHEN IT BECOMES ZERO. THE DOWNSIDE OF THIS IS
C       THE EXTRA COMPUTATION TIME WHILE AUTO CONTINUES THE SOLUTION AFTER
C       PAR(5) HAS CHANGED SIGN, BUT THERE SEEMS NO WAY OF AVOIDING THIS.
      CLOSE(21)
C-----
      DS=-DS
C-----
      OPEN(21,FILE='r.hopf.5otherdirection'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,'' IRS '',I2)')NDIM,IPS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 113 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 113  CONTINUE
      WRITE(21,'('' 1 '',/,'' 5  0. '')')
C     A NOTE ABOUT THE METHODOLOGY: IN MANY OTHER AUTO RUNS THE OUTPUT
C       LABEL HAS BEEN SPECIFIED AS NEGATIVE SO THAT AUTO OUTPUTS WHEN
C       IT REACHES THE REQUIRED VALUE. THEN IT IS NECESSARY TO ASSESS
C       WHETHER OR NOT THE REQUIRED OUTPUT POINT HAS BEEN REACHED. FOR
C       INSTANCE, THE PARAMETERS periodatol AND periodrtol ARE USED FOR
C       THIS PURPOSE WHEN SEARCHING FOR A SOLUTION OF GIVEN PERIOD IN
C       THE periodcontour PROGRAMS. HOWEVER I COULD NOT SEE ANY WAY OF
C       ASSESSING A PRIORI A SUITABLE THRESHOLD FOR PAR(5) AND SO I HAVE
C       LEFT AUTO TO ASSESS WHEN IT BECOMES ZERO. THE DOWNSIDE OF THIS IS
C       THE EXTRA COMPUTATION TIME WHILE AUTO CONTINUES THE SOLUTION AFTER
C       PAR(5) HAS CHANGED SIGN, BUT THERE SEEMS NO WAY OF AVOIDING THIS.
      CLOSE(21)
C-----
C     Write the sixth auto constants file: continuation of the
C     Hopf point in one direction.
C-----
      OPEN(19,FILE='../temp_files/ncrossings.txt',STATUS='OLD')
      READ(19,*)NCROSS
      CLOSE(19)
C-----
      ICP1=1
C      Always use pp as main continuation param for boundary
      ICP2=2
C      The wave speed c
      ICP3=6
C      Im lambda
      ICP4=4
C      gamma
      ICP5=7
C      d(Im e-value)/d(gamma)
      ICP6=3
C      The period
C     Note: the fixed parameters are Re(e-value) 
C           and d(Re e-value)/d(gamma)
      DS=DSIN
C      This is the appropriate value for continuation in pp and c
      DSMIN=DSMNIN
C      This is the appropriate value for continuation in pp and c
      DSMAX=DSMXIN
C      This is the appropriate value for continuation in pp and c
      IUZ=2
      RL0=PPMIN-0.1D0*(PPMAX-PPMIN)
      RL1=PPMAX+0.1D0*(PPMAX-PPMIN)
      UZ1=CMIN-0.1D0*(CMAX-CMIN)
      UZ2=CMAX+0.1D0*(CMAX-CMIN)
C-----
      OPEN(21,FILE='r.hopf.6'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,'' IRS '',I2)')NDIM,IPS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 104 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 104  CONTINUE
      WRITE(21,'(I8)')(NCROSS+2)
      WRITE(21,'(I3,E16.8E2)')(-IUZ),UZ1
      WRITE(21,'(I3,E16.8E2)')(-IUZ),UZ2
      CLOSE(21)
C     Note that the other output values are appended in the calling script
C-----
C     Write the seventh auto constants file: continuation of the
C     Hopf point in the other direction.
C-----
      DS=-DS
C-----
      OPEN(21,FILE='r.hopf.7'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,'' IRS '',I2)')NDIM,IPS,ILP
      WRITE(21,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(21,'(I3,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E15.7E2)')NMX,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')DS,DSMIN,DSMAX,IADS
      WRITE(21,'(''3'',/,''3 0.'',/,''7 0.'',/,''11 0.'')')
C     Note that par(7) is excluded from the pseudo-arclength 
C     because there are no constraints on its value, so that it
C     could get very large. An additional advantage of exclusion
C     is that it ensures that the pseudo-arclengths are comparable
C     in the Eckhaus and Hopf computations, so that it is appropriate
C     to provide a single trio of DS,DSMIN,DSMAX values as inputs and
C     to use these for the computations associated with both types of
C     stability boundary.
      WRITE(21,'(I8)')2*NPTW
      DO 105 I=(3*NPTW+1),(5*NPTW)
         WRITE(21,'(I8,'' 0.'')')I
 105  CONTINUE
      WRITE(21,'(I8)')(NCROSS+2)
      WRITE(21,'(I3,E16.8E2)')(-IUZ),UZ1
      WRITE(21,'(I3,E16.8E2)')(-IUZ),UZ2
      CLOSE(21)
C     Note that the other output values are appended in the calling script
C-----
      STOP
      END
