C+    hopflocus_prepare.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES 
C+    FOR THE CALCULATIONS OF HOPF BIFURCATION LOCI.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      OPEN(14,FILE='../temp_files/hopf.startdata'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)PP1,C1,PP2,C2
      CLOSE(14)
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
      READ(12,*)
      READ(12,*)DS1,DSMIN1,DSMAX1
      READ(12,*)DS2,DSMIN2,DSMAX2
      CLOSE(12)
C-----
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMX1,NMX2
      READ(11,*)A0,A1
      READ(11,*)EPSL,EPSU,EPSS
      CLOSE(11)
C-----
      OPEN(15,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)PPMIN,PPMAX
      READ(15,*)CMIN,CMAX
      CLOSE(15)
C-----
      IPS=1
      IRS=0
      ILP=0
      NICP=1
      IF (PP1.EQ.PP2) THEN
         ICP=2
         DSFCTR=(ABS(CMIN)+ABS(CMAX))/(ABS(PPMIN)+ABS(PPMAX))
         IF (C1.LT.C2) THEN
            RL0=C1
            RL1=C2
            ISIGN=1
         ELSE
            RL0=C2
            RL1=C1
            ISIGN=-1
         ENDIF
      ELSE
         ICP=1
         DSFCTR=1.0D0
         IF (PP1.LT.PP2) THEN
            RL0=PP1
            RL1=PP2
            ISIGN=1
         ELSE
            RL0=PP2
            RL1=PP1
            ISIGN=-1
         ENDIF
      ENDIF
      NCOL=4
      IAD=3
      ISP=0
      ISW=1
      IPLT=0
      NBC=0
      NINT=0
      NPR1=NMX1
      NPR2=NMX2
      MXBF=10
      IID=2
      ITMX=8
      ITNW=5
      NWTN=3
      JAC=0
      IADS=1
C-----
      DS1=DS1*DSFCTR
      DSMIN1=DSMIN1*DSFCTR
      DSMAX1=DSMAX1*DSFCTR
C     Note: the input ds values are for pp. Multiplying by dsfctr has
C           the effect of rescaling appropriately if continuation is
C           done with c as the only continuation parameter.
C-----
      OPEN(13,FILE='r.hopflocus.11'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(13,'(2I8)')NICP,ICP
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX1,RL0,RL1,A0,A1
      WRITE(13,'(I8,6I3)')NPR1,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')(ISIGN*ABS(DS1)),DSMIN1,DSMAX1,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(13)
C-----
      IF (PP1.EQ.PP2) THEN
         ICP1=2
         ICP2=1
         RL0=CMIN-0.1D0*(CMAX-CMIN)
         RL1=CMAX+0.1D0*(CMAX-CMIN)
         UZ1=PPMIN-0.1D0*(PPMAX-PPMIN)
         UZ2=PPMAX+0.1D0*(PPMAX-PPMIN)
      ELSE
         ICP1=1
         ICP2=2
         RL0=PPMIN-0.1D0*(PPMAX-PPMIN)
         RL1=PPMAX+0.1D0*(PPMAX-PPMIN)
         UZ1=CMIN-0.1D0*(CMAX-CMIN)
         UZ2=CMAX+0.1D0*(CMAX-CMIN)
      ENDIF
C     Note: in the above, the range is extended by 10% either side of 
C           ppmax/ppmin or cmax/cmin because this makes the plots 
C           look better in some cases.
      IPS=1
      IRS=2
      NICP=3
      ICP3=11
      ISW=2
C-----
      DO 100 IFILE=22,33,11
         IF (IFILE.EQ.22) THEN
            OPEN(IFILE,FILE='r.hopflocus.22'
     &,STATUS='NEW')
            JSIGN=+1
         ELSE
            OPEN(IFILE,FILE='r.hopflocus.33'
     &,STATUS='NEW')
            JSIGN=-1
         ENDIF
         WRITE(IFILE,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
         WRITE(IFILE,'(4I8)')NICP,ICP1,ICP2,ICP3
         WRITE(IFILE,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
         WRITE(IFILE,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
         WRITE(IFILE,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
         WRITE(IFILE,'(3E16.8E2)')EPSL,EPSU,EPSS
         WRITE(IFILE,'(3E16.8E2,I3)')(JSIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
         WRITE(IFILE,'(''1'',/,''11 0.'',/,''0'',/,''2'')')
         WRITE(IFILE,'(I3,E16.8E2)')(-ICP2),UZ1
         WRITE(IFILE,'(I3,E16.8E2)')(-ICP2),UZ2
         CLOSE(IFILE)
 100  CONTINUE
C-----
      STOP
      END
