C+    iout.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS FILE CONTAINS VARIOUS SUBROUTINES AND FUNCTIONS ASSOCIATED
C+    WITH MANAGING INFORMATION OUTPUT TO THE SCREEN AND THE info.txt
C+    FILE. NOTE THAT IF THERE ARE SUCCESSIVE BLANK LINES IN THE
C+    INPUT FILE message.txt THEN ONLY ONE BLANK LINE IS OUTPUT.
C+    THE FILE ../temp_files/blanks.txt KEEPS TRACK OF WHETHER 
C+    THE LAST LINE OUTPUT TO THE SCREEN AND TO info.txt WAS OR 
C+    WAS NOT BLANK.
C+    NOTE THAT THIS PROGRAM CONTAINS VARIOUS LOOPS WITH A MAXIMUM
C+    COUNTER OF 2000000000. THIS ASSUMES 32-BIT INTEGER ARITHMETIC. 
C++
      SUBROUTINE IOUT(INFO,ATYPE)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*71 AMSSGE,AERROR,ABLANK
      CHARACTER*5 ATYPE
C     Note that there are four possible ATYPE settings:
C         ATYPE='minor' means a minor message
C         ATYPE='major' means a major message
C         ATYPE='error' means an error (but not warning) message 
C                       from a fortran program
C         ATYPE='errsf' means either an error message from a 
C                       script file, or a warning message from
C                       either a script file or a fortran program
      ABLANK=' '
      DO 200 I=1,70
         ABLANK=ABLANK//' '
 200  CONTINUE
      OPEN(93,FILE='../temp_files/blanks.txt'
     &,STATUS='OLD')
      REWIND(93)
      READ(93,*)IBLNKS
      READ(93,*)IBLNKI
      CLOSE(93)
      IF (ATYPE.EQ.'error') THEN
         OPEN(83,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
         WRITE(83,'(''ERROR'')')
         CLOSE(83)
      ENDIF
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      IBLANK=0
      DO 100 I=1,2000000000
         READ(66,9100,END=102)AMSSGE
         IF (AMSSGE.EQ.ABLANK) THEN
            IBLANK=IBLANK+1
         ELSE
            IBLANK=0
         ENDIF
         IF (IBLANK.GT.1) THEN
            GOTO 101
         ENDIF
         IF (ATYPE.EQ.'minor') THEN
            IF (INFO.EQ.4) THEN
               IF ((IBLANK.EQ.0).OR.(IBLNKS.EQ.0)) THEN 
                  WRITE(6,9000)AMSSGE
               ENDIF
               IF (IBLANK.EQ.0) THEN
                  IBLNKS=0
               ELSE
                  IBLNKS=1
               ENDIF
            ENDIF
            IF (INFO.LE.4) THEN
               IF ((IBLANK.EQ.0).OR.(IBLNKI.EQ.0)) THEN 
                  WRITE(77,9000)AMSSGE
               ENDIF
               IF (IBLANK.EQ.0) THEN
                  IBLNKI=0
               ELSE
                  IBLNKI=1
               ENDIF
            ENDIF
            GOTO 101
         ENDIF
         IF (ATYPE.EQ.'major') THEN
            IF (INFO.GE.3) THEN
               IF ((IBLANK.EQ.0).OR.(IBLNKS.EQ.0)) THEN 
                  WRITE(6,9000)AMSSGE
               ENDIF
               IF (IBLANK.EQ.0) THEN
                  IBLNKS=0
               ELSE
                  IBLNKS=1
               ENDIF
            ENDIF
            IF (INFO.LE.4) THEN
               IF ((IBLANK.EQ.0).OR.(IBLNKI.EQ.0)) THEN 
                  WRITE(77,9000)AMSSGE
               ENDIF
               IF (IBLANK.EQ.0) THEN
                  IBLNKI=0
               ELSE
                  IBLNKI=1
               ENDIF
            ENDIF
            GOTO 101
         ENDIF
         IF ((ATYPE.EQ.'error').OR.(ATYPE.EQ.'errsf')) THEN
            IF (INFO.GE.2) THEN
               IF ((IBLANK.EQ.0).OR.(IBLNKS.EQ.0)) THEN 
                  WRITE(6,9000)AMSSGE
               ENDIF
               IF (IBLANK.EQ.0) THEN
                  IBLNKS=0
               ELSE
                  IBLNKS=1
               ENDIF
            ENDIF
            IF (INFO.LE.4) THEN
               IF ((IBLANK.EQ.0).OR.(IBLNKI.EQ.0)) THEN 
                  WRITE(77,9000)AMSSGE
               ENDIF
               IF (IBLANK.EQ.0) THEN
                  IBLNKI=0
               ELSE
                  IBLNKI=1
               ENDIF
            ENDIF
            OPEN(42,FILE='../temp_files/errors.txt'
     &,STATUS='OLD')
      REWIND(42)
            DO 701 I701=1,2000000000
            READ(42,*,END=702)
 701        CONTINUE
            AERROR='ERROR: LOOP 701 FINISHED IN iout.f'
            IF (INFO.GE.2) THEN
               WRITE(6,9000)AERROR
               IBLNKS=0
            ENDIF
            IF (INFO.LE.4) THEN
               WRITE(77,9000)AERROR
               IBLNKI=0
            ENDIF
            WRITE(42,9200)
            WRITE(42,9000)AERROR
            CLOSE(42)
            CLOSE(66)
            RETURN
 702        BACKSPACE(42)
            WRITE(42,9000)AMSSGE
            CLOSE(42)
            GOTO 101
         ENDIF
         WRITE(6,9001)
         IBLNKS=0
         CLOSE(66)
         RETURN
 101     CONTINUE
 100  CONTINUE
      AERROR='ERROR: LOOP 100 FINISHED IN iout.f'
      IF (INFO.GE.2) THEN
         WRITE(6,9000)AERROR
         IBLNKS=0
      ENDIF
      IF (INFO.LE.4) THEN
         WRITE(77,9000)AERROR
         IBLNKI=0
      ENDIF
      OPEN(42,FILE='../temp_files/errors.txt'
     &,STATUS='OLD')
      REWIND(42)
      DO 711 I711=1,2000000000
         READ(42,*,END=712)
 711  CONTINUE
      AERROR='ERROR: LOOP 711 FINISHED IN iout.f'
      IF (INFO.GE.2) THEN
         WRITE(6,9000)AERROR
         IBLNKS=0
      ENDIF
      IF (INFO.LE.4) THEN
         WRITE(77,9000)AERROR
         IBLNKI=0
      ENDIF
      WRITE(42,9200)
      WRITE(42,9000)AERROR
      CLOSE(42)
      CLOSE(66)
      RETURN
 712  BACKSPACE(42)
      WRITE(42,9000)AERROR
      CLOSE(42)
 102  CLOSE(66)
      OPEN(94,FILE='../temp_files/blanks.txt'
     &,STATUS='OLD')
      REWIND(94)
      WRITE(94,9400)IBLNKS
      WRITE(94,9400)IBLNKI
      CLOSE(94)
      RETURN
 9000 FORMAT(A71)
 9001 FORMAT('WARNING: INVALID atype IN SUBROUTINE iout',/,
     &     '         THE MESSAGE IS NOT BEING OUTPUT')
 9100 FORMAT(A71)
 9200 FORMAT('************** WARNING: ******************',/,
     &       ' THE ERROR FILE SEEMS TO BE VERY LONG, AS',/
     &       ' INDICATED BY THE NEXT MESSAGE. ANY OTHER',/, 
     &       ' ERROR MESSAGES THAT APPEARED AFTER THIS',/,
     &       ' POINT IN THE FILE HAVE BEEN LOST')
 9400 FORMAT(I2)
      END
      SUBROUTINE GINFO(INFO)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*71 AERROR,BERROR
      OPEN(88,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(88)
      READ(88,*)IDUMMY,INFO
      CLOSE(88)
      IF (INFO.LE.4) THEN
         OPEN(77,FILE='../temp_files/info.txt'
     &,STATUS='OLD')
      REWIND(77)
         DO 721 I721=1,2000000000
            READ(77,*,END=722)
 721     CONTINUE
         AERROR='ERROR: LOOP 721 FINISHED IN iout.f'
         IF (INFO.GE.2) THEN
            WRITE(6,9000)AERROR
            IBLNKS=0
         ENDIF
         IF (INFO.LE.4) THEN
            WRITE(77,9300)
            WRITE(77,9000)AERROR
            IBLNKI=0
         ENDIF
         OPEN(42,FILE='../temp_files/errors.txt'
     &,STATUS='OLD')
      REWIND(42)
         DO 731 I731=1,2000000000
            READ(42,*,END=732)
 731     CONTINUE
         BERROR='ERROR: LOOP 731 FINISHED IN iout.f'
         IF (INFO.GE.2) THEN
            WRITE(6,9000)BERROR
            IBLNKS=0
         ENDIF
         IF (INFO.LE.4) THEN
            WRITE(77,9000)BERROR
            IBLNKI=0
         ENDIF
         WRITE(42,9200)
         WRITE(42,9000)AERROR
         WRITE(42,9000)BERROR
         CLOSE(42)
         RETURN
 732     BACKSPACE(42)
         WRITE(42,9000)AERROR
         CLOSE(42)
         RETURN
 722     BACKSPACE(77)
      ENDIF
      RETURN
 9000 FORMAT(A71)
 9200 FORMAT('************** WARNING: ******************',/,
     &       ' THE ERROR FILE SEEMS TO BE VERY LONG, AS',/
     &       ' INDICATED BY THE NEXT MESSAGE. ANY OTHER',/, 
     &       ' ERROR MESSAGES THAT APPEARED AFTER THIS',/,
     &       ' POINT IN THE FILE HAVE BEEN LOST')
 9300 FORMAT('************** WARNING: ******************',/,
     &       ' THE INFO FILE SEEMS TO BE VERY LONG, AS',/
     &       ' INDICATED BY THE NEXT MESSAGE. ANY OTHER',/, 
     &       ' ERROR MESSAGES THAT APPEARED AFTER THIS',/,
     &       ' POINT IN THE FILE HAVE BEEN LOST')
      END
      SUBROUTINE ISTOP(INFO)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      IF (INFO.LE.4) THEN
         CLOSE(77)
      ENDIF
      STOP
      END
