C+    hb_and_folds_split.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM SPLITS UP THE DATA FILE FOR LABELS
C+    OF HOPF BIFURCATIONS, FOLDS AND END POINTS IN 
C+    BIFURCATION DIAGRAMS, GIVING TWO FILES WHICH CONTAIN
C+    LABELS THAT SHOULD BE LEFT- AND RIGHT-JUSTIFIED.
C+    THIS PROGRAM IS COMPILED AND RUN BY bd_labels.script.
C++
      IERROR=0
      OPEN(11,FILE='data_files/hb_and_folds.gpdata',STATUS='OLD')
      REWIND(11)
      OPEN(12,FILE='data_files/hb_and_folds_split.output',STATUS='NEW')
      OPEN(13,FILE='../temp_files/bd_axes_limits.data',STATUS='OLD')
      REWIND(13)
      READ(13,*)XMIN
      READ(13,*)XMAX
      CLOSE(13)
      XMID=(XMIN+XMAX)*0.5D0
      DO 100 I=1,100000
         READ(11,*,END=101)XXX
         IF (XXX.LT.XMID) THEN
            WRITE(12,9001)
         ELSE
            WRITE(12,9002)
         ENDIF
 100  CONTINUE
      PRINT*,'ERROR: LOOP 100 FINISHED IN hb_and_folds_split.f'
      IERROR=1
 101  CLOSE(11)
      CLOSE(12)
      OPEN(13,FILE='../temp_files/hb_and_folds_split.error',
     &     STATUS='NEW')
      WRITE(13,'(I2)')IERROR
      CLOSE(13)
      STOP
 9001 FORMAT('1')
 9002 FORMAT('2')
      END
