#+ line.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
# SOFTWARE WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE SUPERIMPOSES AN 
#+ EXTRA LINE ONTO THE CURRENT PLOT. THE FOUR
#+ ARGUMENTS ARE THE START AND END COORDINATES.
#++
if ("$#"<4) print "ERROR: no enough arguments: four coordinates are required" ; exit
if ("$#">4) print "ERROR: too many arguments: only four coordinates are required" ; exit
system "test_sign.script $0"
if (system("cat ../temp_files/test_sign.error") eq "1") exit
system "test_sign.script $1"
if (system("cat ../temp_files/test_sign.error") eq "1") exit
system "test_sign.script $2"
if (system("cat ../temp_files/test_sign.error") eq "1") exit
system "test_sign.script $3"
if (system("cat ../temp_files/test_sign.error") eq "1") exit
iline=iline+1
system "../plotprepare_extras2.script $0 $1 $2 $3 ".gprintf("%18.10g",GPVAL_X_MIN)." ".gprintf("%18.10g",GPVAL_X_MAX)." ".gprintf("%18.10g",GPVAL_Y_MIN)." ".gprintf("%18.10g",GPVAL_Y_MAX)
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
system "create_line_data.script data_files/extraline.data_".iline." $0 $1 $2 $3"
cmdextraline='"data_files/extraline.data_'.iline.'" using 1:2:2 with lines '. extralinetype.' '. extralinethickness.' linecolor '. extralinecolour
# Note that in the above line a space is needed between the dots and the extra's, otherwise gnuplot
#  gets confused about the .e being an exponent and gives an error.
# Note that the 3rd entry for "using" is ignored except in spectrum
#  plots using variable colour.
if (mpon eq "no") call "reset_output.gp"
replot @cmdextraline
system '../writerecord.script "@line \"$0\" \"$1\" \"$2\" \"$3\""'
