#+ pplane_rcode.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
# SOFTWARE WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE READS IN AND PLOTS THE DATA ASSOCIATED
#+ WITH A PARAMETER PLANE WHEN THE REQUESTED PARAMETER PLANE 
#+ TYPE IS "rcode". IT IS CALLED BY pplane.gp.
#++
# Set vertical spacing: this will produce two lines with little or no overlap,
#   centred approximately at the specified labelling point
if (pplanecodesfactor<2.1) vspace="NEWLINE" ; voff=pplanecodesfactor*0.5 ; \
 else if (pplanecodesfactor<3.2) vspace="NEWLINENEWLINE" ; voff=pplanecodesfactor*0.5+1.0 ; \
 else if (pplanecodesfactor<4.4) vspace="NEWLINENEWLINENEWLINE" ; voff=pplanecodesfactor*0.5+1.5 ; \
 else vspace="NEWLINENEWLINENEWLINENEWLINE" ; voff=pplanecodesfactor*0.5+2.0
# Split up data file into separate files for each outcome code
 system "selectdata7.script data_files/combined_outcomes.data data_files/pp.dat1 1 '".pplanecodesexpand."' '".textend.vspace.pplanecodesexpand."' '".textend."'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
 system "selectdata7.script data_files/combined_outcomes.data data_files/pp.dat2 2 '".pplanecodesexpand."' '".textend.vspace.pplanecodesexpand."' '".textend."'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
 system "selectdata7.script data_files/combined_outcomes.data data_files/pp.dat3 3 '".pplanecodesexpand."' '".textend.vspace.pplanecodesexpand."' '".textend."'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
 system "selectdata7.script data_files/combined_outcomes.data data_files/pp.dat4 4 '".pplanecodesexpand."' '".textend.vspace.pplanecodesexpand."' '".textend."'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
 system "selectdata7.script data_files/combined_outcomes.data data_files/pp.dat5 5 '".pplanecodesexpand."' '".textend.vspace.pplanecodesexpand."' '".textend."'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
# Now generate appropriate plot commands
empty1=system("emptytest.script data_files/pp.dat1")
if (system("cat ../temp_files/emptytest.error") eq "1") exit
empty2=system("emptytest.script data_files/pp.dat2")
if (system("cat ../temp_files/emptytest.error") eq "1") exit
empty3=system("emptytest.script data_files/pp.dat3")
if (system("cat ../temp_files/emptytest.error") eq "1") exit
empty4=system("emptytest.script data_files/pp.dat4")
if (system("cat ../temp_files/emptytest.error") eq "1") exit
empty5=system("emptytest.script data_files/pp.dat5")
if (system("cat ../temp_files/emptytest.error") eq "1") exit
if (empty1==0) cmd1="" ;\
 else cmd1=' "data_files/pp.dat1" using 1:2:3 with labels textcolor '.colour1.' offset character 0,voff,\
 "data_files/pp.dat1" using 1:2 with points pointtype 7 pointsize 0.5 linecolor '.colour1
if (empty2==0) cmd2="" ;\
 else cmd2=' "data_files/pp.dat2" using 1:2:3 with labels textcolor '.colour2.' offset character 0,voff,\
 "data_files/pp.dat2" using 1:2 with points pointtype 7 pointsize 0.5 linecolor '.colour2
if (empty3==0) cmd3="" ;\
 else cmd3=' "data_files/pp.dat3" using 1:2:3 with labels textcolor '.colour3.' offset character 0,voff,\
 "data_files/pp.dat3" using 1:2 with points pointtype 7 pointsize 0.5 linecolor '.colour3
if (empty4==0) cmd4="" ;\
 else cmd4=' "data_files/pp.dat4" using 1:2:3 with labels textcolor '.colour4.' offset character 0,voff,\
 "data_files/pp.dat4" using 1:2 with points pointtype 7 pointsize 0.5 linecolor '.colour4
if (empty5==0) cmd5="" ;\
 else cmd5=' "data_files/pp.dat5" using 1:2:3 with labels textcolor '.colour5.' offset character 0,voff,\
 "data_files/pp.dat5" using 1:2 with points pointtype 7 pointsize 0.5 linecolor '.colour5
if (empty1==1 && empty2+empty3+empty4+empty5>0) end1="," ; else end1=""
if (empty2==1 && empty3+empty4+empty5>0) end2="," ; else end2=""
if (empty3==1 && empty4+empty5>0) end3="," ; else end3=""
if (empty4==1 && empty5>0) end4="," ; else end4=""
# Finally, do the plot
plot @cmd1@end1@cmd2@end2@cmd3@end3@cmd4@end4@cmd5
