#+ ptw.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
# SOFTWARE WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE PLOTS THE PERIODIC
#+ TRAVELLING WAVE. THE ARGUMENT IS THE rcode NUMBER.
#++
if ("$#"==0) print "ERROR: no rcode number was given" ; exit
if ("$#">1) print "ERROR: too many arguments: only an rcode number is required" ; exit
unset label
unset xlabel
unset ylabel
unset multiplot ; mpon="no"
unset xzeroaxis
unset yzeroaxis
set tics nooffset
system "../plotprepare_ptw.script ".subdir." ".pdir." $0"
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
outputdir=pdir."/rcode$0/"
title1=titlesexpand.system("getline.script 1 ../temp_files/plotprepare_ptw.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
title2=titlesexpand.system("getline.script 2 ../temp_files/plotprepare_ptw.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
xlabeltext=labelsexpand.system("getline.script 3 ../temp_files/plotprepare_ptw.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
nptw=system("getline.script 2 ../temp_files/variables.numbers")
if (system("cat ../temp_files/getline.error") eq "1") exit
xwidth=1.0-leftspace-rightspace
ywidth=1.0-topspace-bottomspace
panelheight=ywidth/nptw
if (showtitles eq "yes") set label title1 at screen xtitle,(1.0-topspace*0.25) center textcolor rgb "black" \
 offset character 0,(titlesfactor-1.0)*0.5
if (showtitles eq "yes") set label title2 at screen xtitle,(1.0-topspace*0.75) center textcolor rgb "black" \
 offset character 0,(titlesfactor-1.0)*0.5
set xrange [*:*] noreverse nowriteback 
set yrange [*:*] noreverse nowriteback 
# Set size and origin before setting multiplot so that the
#   bounding box includes all of the panels in a postscript file
set size 1.0-leftspace-rightspace,1.0-topspace-bottomspace
set origin leftspace,bottomspace
set multiplot ; mpon="yes"
variablenumber=1
load "ptw_nextpanel.gp"
unset multiplot ; mpon="no"
