#+ set_colours_nextcolour.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
# SOFTWARE WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE IS CALLED BY set_colours.gp 
#+ AND SETS UP THE LABEL ASSOCIATED WITH ONE OF THE COLOURS
#+ IN ../list_of_colours.txt
#++
colourname=system("getline.script ".icolour." ../temp_files/colournames.txt")
colourcode=system("getline.script ".icolour." ../temp_files/colourcodes.txt")
if (system("cat ../temp_files/getline.error") eq "1") exit
if (colourname eq "white" || colourname eq "grey50" || colourname eq "grey49" || colourname eq "grey48" || colourname eq "grey47" ||  colourname eq "grey46" || colourname eq "grey45" || colourname eq "grey44" || colourname eq "grey43" || colourname eq "grey42" || colourname eq "grey41" || colourname eq "grey40" || colourname eq "grey39" || colourname eq "grey38" || colourname eq "grey37" || colourname eq "grey36" || colourname eq "grey35" ) xcolour1=icolumn-0.25 ; xcolour2=icolumn+0.25 ; else xcolour1=icolumn ; xcolour2=-1
ycolour=nrows+1-irow
set label colourname at xcolour1,ycolour center textcolor @colourcode
if (xcolour2>0) set label colourname at xcolour2,ycolour center textcolor @colourcode
xrectangle1=icolumn+0.05
yrectangle1=nrows+0.5-irow
xrectangle2=icolumn+0.45
yrectangle2=nrows+1.5-irow
if (xcolour2>0) set object rectangle from xrectangle1,yrectangle1 to xrectangle2,yrectangle2 behind fillcolor rgb "black" fillstyle solid
if (irow==nrows) icolumn=icolumn+1 ; irow=1 ; else irow=irow+1
icolour=icolour+1
if (icolour<=ncolours) reread
