#+ set_style.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
# SOFTWARE WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE ESTABLISHES THE SETTINGS FOR COLOURS, 
#+   LINE STYLES AND LINE THICKNESSES, BY READING THEM FROM THE
#+   FILE $1.style. IT ALSO UPDATES THE pplane_key POSTSCRIPT FILE
#+   AND STARTS A NEW SCREEN PLOTTING SESSION.
#++
if ("$#"==0) print "ERROR: no style file name was given" ; exit
if ("$#">1) print "ERROR: too many arguments: only a style file name (no extension) is required" ; exit
system "../plotprepare_set_style_gnuplot.script $0"
if (system("cat ../temp_files/plotprepare_set_style.output") eq "0" && firstsetstyle eq "yes") \
 print "The setting for defaultstyle in plot_defaults.input is invalid." ; \
 print "The plotter will now exit." ; \
 @quit
if (system("cat ../temp_files/plotprepare_set_style.output") eq "0") exit
load "data_files/smallstyle.gp"
unset multiplot ; mpon="no"
set terminal @default_terminal
set output
canvaswidthchars=screenwidthchars
clear
system "fixboundingbox.script ".gprintf("%9.6f",bottomspace)." ".gprintf("%9.6f",leftspace)." ".gprintf("%9.6f",rightspace)." ".gprintf("%9.6f",topspace)." 1"
system "../endrecord.script"
# This initial return to screen output is included in case a
#   postscript file is currently being written; the above 
#   lines complete the writing of this file.
system "../filerm.script ../../postscript_files/".subdir."/pplane_key.ps"
system "../filerm.script ../../postscript_files/".subdir."/pplane_key.eps"
set terminal postscript eps color size 3.5in,5in enhanced "Helvetica" 14
canvaswidthchars=95 # for Helvetica,14 font
set output "../../postscript_files/".subdir."/pplane_key.eps"
call "data_files/textexpand_ps.gp"
call "data_files/textfactors_ps.gp"
call "data_files/textmisc_ps.gp"
@pplane_key
call "screen.gp"
system "fixboundingbox.script ".gprintf("%9.6f",bottomspace)." ".gprintf("%9.6f",leftspace)." ".gprintf("%9.6f",rightspace)." ".gprintf("%9.6f",topspace)." 3 ".subdir
firstsetstyle="no"
