#+ hopf_locus.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
# SOFTWARE WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE PLOTS STABILITY BOUNDARY CURVES.
#+ THERE IS ONE ARGUMENT, WHICH IS EITHER AN scode NUMBER
#+ OR all/All/ALL; IN THE LATTER CASE, BOUNDARY CURVES
#+ CORRESPONDING TO ALL scode VALUES ARE PLOTTED.
#++
if ("$#"==0) print "ERROR: no rcode number was given" ; exit
if ("$#">1) print "ERROR: too many arguments: only an rcode number is required" ; exit
isb=isb+1
system "../plotprepare_sb.script ".pdir." $0"
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
# Now split up the data file into eckhaus and hopf parts
system "selectdata5.script ../temp_files/stabilityboundary.boundarydata \
 data_files/stabilityboundary.gpdata1_".isb
if (system("cat ../temp_files/selectdata.error") eq "1") exit
system "selectdata4.script ../temp_files/stabilityboundary.boundarydata \
 data_files/stabilityboundary.gpdata2_".isb
if (system("cat ../temp_files/selectdata.error") eq "1") exit
# Now generate the plot commands for the lines
empty1=system("emptytest.script data_files/stabilityboundary.gpdata1_".isb)
if (system("cat ../temp_files/emptytest.error") eq "1") exit
empty2=system("emptytest.script data_files/stabilityboundary.gpdata2_".isb)
if (system("cat ../temp_files/emptytest.error") eq "1") exit
if (empty1==0) cmd1="" ;\
 else cmd1=' "data_files/stabilityboundary.gpdata1_'.isb.'" using 1:2 with lines '.\
 sbdyeckhauslinetype.' '.sbdyeckhauslinethickness.' linecolor '.sbdyeckhauscolour
if (empty2==0) cmd2="" ;\
 else cmd2=' "data_files/stabilityboundary.gpdata2_'.isb.'" using 1:2 with lines '.\
 sbdyhopflinetype.' '.sbdyhopflinethickness.' linecolor '.sbdyhopfcolour
if (empty1==1 && empty2==1) end1="," ; else end1=""
# Finally, the plot command
call "reset_output.gp"
replot @cmd1@end1@cmd2
