C+    redo_labels_bd.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE DATA FILE ON LABELLING OF HOPF 
C+    BIFURCATIONS AND FOLDS FOR BIFURCATION DIAGRAM PLOTS, AND
C+    SPLITS IT UP INTO THREE SEPARATE FILES THAT MAKE PLOTTING 
C+    EASIER. THE PROGRAM ALSO ELIMINATES DUPLICATED LABELS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      DIMENSION HBFOLD(7),HBFLD1(7)
      LOGICAL LKEEP
      COMMON/MMCOM/XMIN,XMAX,YMIN,YMAX
      OPEN(20,FILE='../temp_files/bd_axes_limits.data'
     &,STATUS='OLD')
      READ(20,*)XMIN
      READ(20,*)XMAX
      READ(20,*)YMIN
      READ(20,*)YMAX
      CLOSE(20)
      OPEN(11,FILE='data_files/hb_and_folds.data1'
     &,STATUS='NEW')
      OPEN(12,FILE='data_files/hb_and_folds.data2'
     &,STATUS='NEW')
      OPEN(13,FILE='data_files/hb_and_folds.data3'
     &,STATUS='NEW')
      YYY=YMAX+0.1*(YMAX-YMIN)
C     THIS IS OUT OF RANGE BUT OTHERWISE ARBITRARY
      WRITE(11,9000)XMIN,(YYY, I=2,7)
      WRITE(12,9000)XMIN,(YYY, I=2,7)
      WRITE(13,9000)XMIN,(YYY, I=2,7)
C     THESE INITIAL OUTPUT LINES ENSURE THAT THE OUTPUT FILES
C     ARE NOT EMPTY; THE POINTS WILL NOT BE PLOTTED BECAUSE
C     THE Y VALUES ARE ALL OUT OF RANGE
      OPEN(30,FILE='../temp_files/hb_and_folds.data'
     &,STATUS='OLD')
C     Before reading in the data, choose an appropriate number 
C     of significant figures for the output; this will ensure
C     an output form on the plot that is most helpful to the user
      NSGFGX=MAX(4,4-INT(LOG10(ABS(2.0D0*(XMAX-XMIN)
     &     /(XMAX+XMIN)))))
      NSGFGY=MAX(3,3-INT(LOG10(ABS(2.0D0*(YMAX-YMIN)
     &     /(YMAX+YMIN)))))
      OPEN(25,FILE='../temp_files/redo_labels_bd.input'
     &,STATUS='OLD')
      REWIND(25)
      READ(25,*)NLINES
      CLOSE(25)
      DO 100 I=1,NLINES
         READ(30,*,END=930)(HBFOLD(IJ),IJ=1,7),ITYPE
C        ITYPE=1 denotes Hopf bifurcation point
C        ITYPE=2 denotes fold
C        ITYPE=3 denotes end point
         LKEEP=.TRUE.
         OPEN(31,FILE='../temp_files/hb_and_folds.data.copy'
     &,STATUS='OLD')
         REWIND(31)
         DO 200 J=1,NLINES
            READ(31,*,END=931)(HBFLD1(IJ),IJ=1,7),ITYPE1
            DIFF=ABS(HBFOLD(1)-HBFLD1(1))
C           Note: the significance of DIFF is that it prevents
C             labels for lots of folds at almost identical
C             parameter values being superimposed on top
C             of one another. Auto typically detects a
C             number of such folds shortly being exitting
C             with a convergence error close to a
C             homoclinic solution. Then the desired label
C             is "End point", which should override the "Fold"
C             labels. Sometimes auto turns around at a Hopf
C             bifurcation point: then the "Fold" label should
C             be overridden by "Hopf bifn". The choice of
C             1% of the plotting range as the threshold is
C             arbitrary.
            IF ((DIFF.LT.(0.01D0*(XMAX-XMIN))).AND.(I.NE.J)) THEN
               IF (ITYPE.EQ.1) THEN
                  IF ((ITYPE1.EQ.1).AND.(I.LT.J)) THEN
                     LKEEP=.FALSE.
                  ENDIF
               ENDIF
               IF (ITYPE.EQ.2) THEN
                  IF ((ITYPE1.EQ.1).OR.(ITYPE1.EQ.3)) THEN
                     LKEEP=.FALSE.
                  ENDIF
                  IF ((ITYPE1.EQ.2).AND.(I.LT.J)) THEN
                     LKEEP=.FALSE.
                  ENDIF
               ENDIF
               IF (ITYPE.EQ.3) THEN
                  IF (ITYPE1.EQ.1) THEN
                     LKEEP=.FALSE.
C                    Note: This is an unexpected situation, in which
C                          an end point and a Hopf bifurcation coincide.
C                          The Hopf bifurcation label is chosen since 
C                          this should always take precedence.
                  ENDIF
                  IF ((ITYPE1.EQ.3).AND.(I.LT.J)) THEN
                     LKEEP=.FALSE.
                  ENDIF
               ENDIF
            ENDIF
 200     CONTINUE
         CLOSE(31)
         IF (LKEEP) THEN
            CALL OUTPUT(HBFOLD,ITYPE,NSGFGX,NSGFGY)
         ENDIF
 100  CONTINUE
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(30)
      STOP
 930  PRINT*,'ERROR IN redo_labels_bd.f'
      PRINT*,'      UNEXPECTED END OF FILE 30'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(30)
      STOP
 931  PRINT*,'ERROR IN redo_labels_bd.f'
      PRINT*,'      UNEXPECTED END OF FILE 31'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(30)
      CLOSE(31)
      STOP
 9000 FORMAT(7E12.4E2)
      END

      SUBROUTINE OUTPUT(HBFOLD,ITYPE,NSGFGX,NSGFGY)
C     Note that the number of Y significant figures was transfered in
C     anticipation of using the Y values for labelling, but in the 
C     end I decided to label only with X
      IMPLICIT REAL*8 (A-H,K,O-Z)
      DIMENSION HBFOLD(7)
      COMMON/MMCOM/XMIN,XMAX,YMIN,YMAX
      IUNIT=ITYPE+10
      IF ((HBFOLD(1).GT.XMIN).AND.(HBFOLD(1).LT.XMAX)) THEN
         IF (NSGFGX.LE.4) THEN
            WRITE(IUNIT,9004)(HBFOLD(I),I=1,7)
         ENDIF
         IF (NSGFGX.EQ.5) THEN
            WRITE(IUNIT,9005)(HBFOLD(I),I=1,7)
         ENDIF
         IF (NSGFGX.EQ.6) THEN
            WRITE(IUNIT,9006)(HBFOLD(I),I=1,7)
         ENDIF
         IF (NSGFGX.EQ.7) THEN
            WRITE(IUNIT,9007)(HBFOLD(I),I=1,7)
         ENDIF
         IF (NSGFGX.EQ.8) THEN
            WRITE(IUNIT,9008)(HBFOLD(I),I=1,7)
         ENDIF
         IF (NSGFGX.EQ.9) THEN
            WRITE(IUNIT,9009)(HBFOLD(I),I=1,7)
         ENDIF
         IF (NSGFGX.GE.10) THEN
            WRITE(IUNIT,9010)(HBFOLD(I),I=1,7)
         ENDIF
      ENDIF
      RETURN
 9004 FORMAT(E12.4E2,6E18.10E2)
 9005 FORMAT(E13.5E2,6E18.10E2)
 9006 FORMAT(E14.6E2,6E18.10E2)
 9007 FORMAT(E15.7E2,6E18.10E2)
 9008 FORMAT(E16.8E2,6E18.10E2)
 9009 FORMAT(E17.9E2,6E18.10E2)
 9010 FORMAT(E18.10E2,6E18.10E2)
      END
