C+    shade_selectdata_part1.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS IS PART 1 OF A TWO PART PROGRAM.
C+    The arguments given to @shade specify a series of bounding
C+    curves. For each of these curves, the data file created by
C+    the Wavetrain run is in two parts, separated by a row of zeros
C+    in the file, since the curve is calculated starting in the 
C+    middle and proceeding first in one direction and then in the 
C+    other direction. This program splits the two parts into separate
C+    files, including only those data points that satisfy the 
C+    inequality (or inequalities) given in the arguments to @shade.
C+    Note that one of the parts may not contain any points: then an
C+    empty file will be created.
C+    Note that this program is split into two parts, in separate files.
C+    They are combined before running (in plotprepare_shade.script)
C+    with a section in between corresponding to the inequality or 
C+    inequalities given in the arguments to @shade.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      OPEN(11,FILE='data_files/shade_selectdata.input'
     &,STATUS='OLD')
      REWIND(11)
      OPEN(12,FILE='data_files/shade_selectdata.nlines'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)NDATA
      CLOSE(12)
      OPEN(21,FILE='data_files/shade_selectdata.output1'
     &,STATUS='NEW')
      OPEN(22,FILE='data_files/shade_selectdata.output2'
     &,STATUS='NEW')
C
      IWHICH=1
C     The variable IWHICH is used to keep track of whether
C       the data being read in is from an initial block of
C       zeros, the first block of data, the middle block of
C       zeros, the second block of data, or a final block of
C       zeros (IWHICH=1,2,3,4,5 respectively).
      DO 100 I=1,NDATA
         READ(11,*)PP,C,IFLAG
C        Check whether IWHICH needs to be changed 
         IF ((IWHICH.EQ.1).AND.(IFLAG.GT.0)) THEN
            IWHICH=2
            IFILE=21
         ENDIF
         IF ((IWHICH.EQ.2).AND.(IFLAG.EQ.0)) THEN
            IWHICH=3
         ENDIF
         IF ((IWHICH.EQ.3).AND.(IFLAG.GT.0)) THEN
            IWHICH=4
            IFILE=22
         ENDIF
         IF ((IWHICH.EQ.4).AND.(IFLAG.EQ.0)) THEN
            IWHICH=5
         ENDIF
C        Now write to output file if appropriate
         IF ((IWHICH.EQ.2).OR.(IWHICH.EQ.4)) THEN
            CALL OUTPUT(IFILE,PP,C)
         ENDIF
C
 100  CONTINUE
      CLOSE(21)
      CLOSE(22)
      STOP
      END

      SUBROUTINE OUTPUT(IFILE,PP,C)
      IMPLICIT REAL*8 (A-H,K,O-Z)
C     THIS IS THE END OF THIS PART OF THE PROGRAM
