C     equations.f
C     THIS FILE HAS BEEN AUTOMATICALLY GENERATED BY 
C     process_equations.script, BASED ON THE INPUT FILES
C     variables.input, other_parameters.input AND 
C     equations.input, PLUS THE CONSTANTS inttype (DEFINED
C     IN constants.input) AND order (DEFINED IN 
C     defaults.input). IT CONTAINS SUBROUTINES THAT 
C     DEFINE THE EQUATIONS TO BE STUDIED. 
C-----------------------------------------------------------------------
      REAL*8 FUNCTION STEP1(X)
C***********************************************************************
C     This function defines a step function, which is not available
C     as an intrinsic function in Fortran. At zero, the step function
C     is equal to zero.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      ZERO=0.0D0
      IF (X.LT.ZERO) THEN
      STEP1=0.0D0
      ENDIF
      IF (X.EQ.ZERO) THEN
      STEP1=0.0D0
      ENDIF
      IF (X.GT.ZERO) THEN
      STEP1=1.0D0
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      REAL*8 FUNCTION STEP2(X)
C***********************************************************************
C     This function defines a step function, which is not available
C     as an intrinsic function in Fortran. At zero, the step function
C     is equal to 0.5.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      ZERO=0.0D0
      IF (X.LT.ZERO) THEN
      STEP2=0.0D0
      ENDIF
      IF (X.EQ.ZERO) THEN
      STEP2=0.5D0
      ENDIF
      IF (X.GT.ZERO) THEN
      STEP2=1.0D0
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      REAL*8 FUNCTION STEP3(X)
C***********************************************************************
C     This function defines a step function, which is not available
C     as an intrinsic function in Fortran. At zero, the step function
C     is equal to one.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      ZERO=0.0D0
      IF (X.LT.ZERO) THEN
      STEP3=0.0D0
      ENDIF
      IF (X.EQ.ZERO) THEN
      STEP3=1.0D0
      ENDIF
      IF (X.GT.ZERO) THEN
      STEP3=1.0D0
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE TWEQS(NPTW,PP,C,UPTW,DUPTWZ)
C***********************************************************************
C     THIS SUBROUTINE SPECIFIES THE TRAVELLING WAVE EQUATIONS, WRITTEN 
C     AS A SYSTEM OF FIRST ORDER ORDINARY DIFFERENTIAL EQUATIONS.
C     INPUTS: NPTW: THE ORDER OF THE TRAVELLING WAVE ORDINARY 
C                   DIFFERENTIAL EQUATIONS, I.E. THE NUMBER OF 
C                   EQUATIONS WHEN THESE ARE WRITTEN AS A SYSTEM
C                   OF FIRST ORDER EQUATIONS
C             PP: THE CONTROL PARAMETER
C             C: THE WAVE SPEED
C             UPTW: AN ARRAY OF DIMENSION = NUMBER OF EQUATIONS, GIVING 
C                   THE TRAVELLING WAVE VARIABLES.
C     OUTPUTS: DUPTWZ: AN ARRAY OF DIMENSION = NUMBER OF EQUATIONS, 
C                       GIVING THE DERIVATIVES OF EACH OF THE TRAVELLING
C                       WAVE VARIABLES WITH RESPECT TO THE TRAVELLING WAVE
C                       COORDINATE Z. NOTE THAT WHEN THESE ARE USED IN 
C                       CONTINUATION OF THE SPECTRUM, THE WAVE COORDINATE 
C                       IS RESCALED BY THE WAVELENGTH OF THE PERIODIC 
C                       TRAVELLING WAVE, AND THIS RESCALING IS DONE 
C                       AUTOMATICALLY WITHIN THE AUTO FILES.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      INTEGER NPTW
      DIMENSION UPTW(NPTW),DUPTWZ(NPTW)
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      DUPTWZ(1)=(UPTW(2))
      DUPTWZ(2)=(-C*UPTW(2)-UPTW(3)*UPTW(1)*UPTW(1)+PARAM(1)*UPTW(
     &1))
      DUPTWZ(3)=((UPTW(3)*UPTW(1)*UPTW(1)+UPTW(3)-PP)/(PARAM(2)+C)
     &)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EFEQNS(NPTW,PP,C,UPTW,AMATRX,BMATRX)
C***********************************************************************
C     THIS SUBROUTINE SPECIFIES THE EIGENFUNCTION EQUATIONS GIVEN BY
C     LINEARISING THE GOVERNING PARTIAL DIFFERENTIAL EQUATIONS ABOUT 
C     THE PERIODIC TRAVELLING WAVE SOLUTION. 
C     FOR ANY SYSTEM OF EQUATIONS COVERED BY THE PACKAGE, THESE
C     EIGENFUNCTION EQUATIONS WILL HAVE THE FORM
C             du/dz = A*u + lambda*B*u
C     WHERE u IS THE EIGENFUNCTION, lambda IS THE EIGENVALUE, 
C     AND A AND B ARE MATRICES THAT DEPEND ON THE PERIODIC 
C     TRAVELLING WAVE SOLUTION. THIS SUBROUTINE RETURNS THE 
C     MATRICES A AND B, FROM WHICH THE EIGENFUNCTION EQUATIONS 
C     CAN BE CONSTRUCTED.
C     INPUTS: NPTW: THE ORDER OF THE TRAVELLING WAVE ORDINARY 
C                   DIFFERENTIAL EQUATIONS, I.E. THE NUMBER OF 
C                   EQUATIONS WHEN THESE ARE WRITTEN AS A SYSTEM
C                   OF FIRST ORDER EQUATIONS
C             PP: THE CONTROL PARAMETER
C             C: THE WAVE SPEED
C             UPTW: AN ARRAY OF DIMENSION = NUMBER OF EQUATIONS, GIVING 
C                   THE TRAVELLING WAVE VARIABLES.
C     OUTPUTS: AMATRX: A TWO DIMENSIONAL ARRAY OF DIMENSION NPTW x NPTW 
C                       GIVING THE MATRIX A AS DEFINED ABOVE.
C              BMATRX: A TWO DIMENSIONAL ARRAY OF DIMENSION NPTW x NPTW 
C                       GIVING THE MATRIX B AS DEFINED ABOVE.
C              NOTE THAT IN CONTINUATION OF THE SPECTRUM, THE WAVE 
C              COORDINATE IS RESCALED BY THE WAVELENGTH OF THE PERIODIC 
C              TRAVELLING WAVE, AND THIS RESCALING IS DONE AUTOMATICALLY 
C              WITHIN THE AUTO FILES.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      INTEGER NPTW
      DIMENSION UPTW(NPTW),AMATRX(NPTW,NPTW),BMATRX(NPTW,NPTW)
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      AMATRX(1,1)=(0.0D0)
      AMATRX(1,2)=(1.0D0)
      AMATRX(1,3)=(0.0D0)
      AMATRX(2,1)=(PARAM(1)-2.0D0*UPTW(1)*UPTW(3))
      AMATRX(2,2)=(-C)
      AMATRX(2,3)=(-UPTW(1)**2)
      AMATRX(3,1)=(2.0D0*UPTW(1)*UPTW(3)/(PARAM(2)+C))
      AMATRX(3,2)=(0.0D0)
      AMATRX(3,3)=((1.0D0+UPTW(1)**2)/(PARAM(2)+C))
      BMATRX(1,1)=(0.0D0)
      BMATRX(1,2)=(0.0D0)
      BMATRX(1,3)=(0.0D0)
      BMATRX(2,1)=(1.0D0)
      BMATRX(2,2)=(0.0D0)
      BMATRX(2,3)=(0.0D0)
      BMATRX(3,1)=(0.0D0)
      BMATRX(3,2)=(0.0D0)
      BMATRX(3,3)=(1.0D0/(PARAM(2)+C))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE STST(NPTW,PP,C,USS,EXIST1)
C***********************************************************************
C     THIS SUBROUTINE DEFINES THE STEADY STATE FROM WHICH PERIODIC
C     TRAVELLING WAVES DEVELOP, VIA A HOPF BIFURCATION IN THE 
C     TRAVELLING WAVE EQUATIONS. THE STEADY STATE WILL (TYPICALLY) 
C     DEPEND ON THE CONTROL PARAMETER PP, BUT WILL BE INDEPENDENT OF
C     THE WAVE SPEED C; NEVERTHELESS C APPEARS IN THE CALL STATEMENT,
C     BECAUSE IT IS REQUIRED IF IT PROVES NECESSARY TO CALL HBLIMS.
C     THIS VALUE OF C IS ALSO USED FOR THE ARBITRARY PARAMETER CSS,
C     WHICH MUST BE TRANSFERED TO FCNSS VIA A COMMON BLOCK BECAUSE THE
C     EQUATIONS USED FOR THE STEADY STATE ARE THE TRAVELLING WAVE 
C     EQUATIONS, AND THUS INVOLVE C EVEN THOUGH THE STEADY STATE
C     CANNOT DEPEND ON C. (ANOTHER POSSIBILITY WOULD BE TO SET CSS=0,
C     BUT THIS CAN RESULT IN DIVISION BY ZERO IN SOME CASES).
C     NOTE THAT IN SOME CASES, THE STEADY STATE WILL EXIST ONLY FOR 
C     SOME VALUES OF PP. MOREOVER, WHEN THE STEADY STATE DOES EXIST,
C     ONE MAY NOT HAVE AN EXACT FORMULA FOR IT, IN WHICH CASE IT IS
C     NECESSARY TO SOLVE NUMERICALLY, USING THE USER-SUPPLIED FORMULA
C     AS AN INITIAL GUESS FOR THE SOLUTION.
C     INPUTS: NPTW: THE ORDER OF THE TRAVELLING WAVE ORDINARY 
C                   DIFFERENTIAL EQUATIONS, I.E. THE NUMBER OF 
C                   EQUATIONS WHEN THESE ARE WRITTEN AS A SYSTEM
C                   OF FIRST ORDER EQUATIONS
C             PP: THE CONTROL PARAMETER
C             C: THE WAVE SPEED. THIS DOES NOT AFFECT THE STEADY
C                STATES, BUT IT IS TRANSFERED TO THE SUBROUTINE 
C                IN CASE HBLIMS HAS TO BE CALLED.
C             EXIST1: EXIST1=.FALSE. GIVES NORMAL OPERATION OF THE
C                     SUBROUTINE, I.E. CALCULATION OF THE STEADY
C                     STATE. IF EXIST1=.TRUE. ON ENTRY THEN THE 
C                     SUBROUTINE ONLY CHECKS WHETHER THE STEADY 
C                     STATE EXISTS; THEREFORE THE OUTPUT VALUES OF 
C                     USS SHOULD NOT BE USED (THEY WILL NOT HAVE  
C                     BEEN VERIFIED VIA NUMERICAL SOLUTION).
C     OUTPUTS: PP: IF A STEADY STATE EXISTS FOR THE INPUT VALUE OF PP,
C                  THEN pp WILL NOT BE CHANGED, BUT IF A STEADY STATE
C                  DOES NOT EXIST THEN pp WILL BE CHANGED TO A VALUE
C                  INSIDE THE RANGE SPECIFIED BY hblims AND THEN
C                  THE STEADY STATE WILL BE CALCULATED.
C              USS: AN ARRAY OF DIMENSION = NUMBER OF PTW EQUATIONS,
C                   SPECIFYING THE STEADY STATE FOR EACH VARIABLE 
C                   IN TURN. 
C              EXIST1: THIS INDICATES WHETHER THE STEADY STATE
C                      EXISTS FOR THE GIVEN VALUES OF THE CONTROL
C                      PARAMETER AND WAVE SPEED. NOTE THAT THE VALUES
C                      IN THE ARRAY USS MAY BE MEANINGFUL EVEN IF 
C                      EXIST1=.FALSE. ON EXIT, BECAUSE THEY MAY
C                      CONTAIN THE VALUES OF THE STEADY STATE FOR 
C                      A DIFFERENT CONTROL PARAMETER VALUE. 
C                      
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      IMPLICIT INTEGER ( I, J, L, M, N )
      LOGICAL EXISTS, AUTO, EXIST1
      DIMENSION USS(NPTW)
      COMMON / PPCCOM / PP1, CSS 
C     The spaces in the above line prevent substitutions
      EXTERNAL FCNSS
      DIMENSION FVECSS(3),WASS(33),UNEW(3),UOLD(3)
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      DO 300 IWHICH=1,2
      IF (((PP).LT.(2.001D0*PARAM(1)))) THEN
      EXISTS=.FALSE.
      ENDIF
      IF (((2.001D0*PARAM(1)).LE.(PP))) THEN
      EXISTS=.TRUE.
      USS(1)=(2.0D0*PARAM(1)/(PP-SQRT(PP**2-4.0D0*PARAM(1)**2)))
      USS(2)=(0.0D0)
      USS(3)=((PP-SQRT(PP**2-4.0D0*PARAM(1)**2))/2.0D0)
      ENDIF
      IF ( EXIST1 ) THEN
      EXIST1=EXISTS
      RETURN
      ENDIF
      EXIST1=EXISTS
      IF ( EXISTS ) THEN
      GOTO 150
      ELSE
      IF (IWHICH.EQ.1) THEN
      WRITE(6,'(''There is no steady state for'')')
      WRITE(6,'('' control parameter='',E18.10E2)')PP
      WRITE(6,'(''Therefore it is being reset to a value'')')
      WRITE(6,'(''that is based on the search range set'')')
      WRITE(6,'(''for seeking a Hopf bifurcation'')')
      AUTO=.TRUE.
      CALL HBLIMS(PP,C,IHDRCT,PPHOPF,HBLIM1,HBLIM2,AUTO)
      IF (IHDRCT.EQ.0) THEN
      PP1=HBLIM1
      PP2=HBLIM2
      IF (((PP-PP1)*(PP-PP2)).LT.0.0D0) THEN
      WRITE(6,'(''Problem in subroutine stst in equations.f'')')
      WRITE(6,'(''The Hopf bifurcation search implied by'')')
      WRITE(6,'('' the control parameter and wave speed'')')
      WRITE(6,'('' values is of direct type, but the'')')
      WRITE(6,'('' control parameter lies between'')')
      WRITE(6,'('' the start and end points of the'')')
      WRITE(6,'('' search range.'')')
      WRITE(6,'(''This indicates a problem with the range'')')
      WRITE(6,'('' of control parameter values set for'')')
      WRITE(6,'('' seeking a Hopf bifurcation.'')')
      OPEN(14,FILE='../temp_files/auto_stst.error',STATUS='NEW')
      WRITE(14,'(''The Hopf bifurcation search implied by'')')
      WRITE(14,'('' the control parameter and wave speed'')')
      WRITE(14,'('' values is of direct type, but the'')')
      WRITE(14,'('' control parameter lies between'')')
      WRITE(14,'('' the start and end points of the'')')
      WRITE(14,'('' search range.'')')
      WRITE(14,'(''This indicates a problem with the range'')')
      WRITE(14,'('' of control parameter values set for'')')
      WRITE(14,'('' seeking a Hopf bifurcation.'')')
      CLOSE(14)
      STOP
      ENDIF
      OPEN(16,FILE='../temp_files/defaults.input',STATUS='OLD')
      REWIND(16)
      READ(16,*)PPATOL
      CLOSE(16)
      IF (PP.LE.PP1) THEN
      PP=MIN(PP1,PP2)+ABS(PPATOL)
      ELSE
      PP=MAX(PP1,PP2)-ABS(PPATOL)
      ENDIF
      ELSE
      IF (IHDRCT.EQ.1) THEN
      PP=PPHOPF
      ELSE
      PP=HBLIM1
      ENDIF
      ENDIF
      WRITE(6,'(''The control parameter has been reset.'')')
      WRITE(6,'(''The new value is:'',E18.10E2)')PP
      ENDIF
      ENDIF
  300 CONTINUE
      WRITE(6,'(''Problem in subroutine stst in equations.f'')')
      WRITE(6,'(''The control parameter has been changed'')')
      WRITE(6,'(''but there is still no steady state.'')')
      WRITE(6,'(''This indicates a problem with the range'')')
      WRITE(6,'(''of control parameter values over which'')')
      WRITE(6,'(''a Hopf bifurcation is being sought.'')')
      OPEN(14,FILE='../temp_files/auto_stst.error',STATUS='NEW')
      WRITE(14,'(''No steady state has been found, even'')')
      WRITE(14,'(''after resetting the control parameter'')')
      WRITE(14,'(''value. This indicates a problem with the'')')
      WRITE(14,'(''range of control parameter values over'')')
      WRITE(14,'(''which a Hopf bifn is being sought.'')')
      CLOSE(14)
      STOP
  150 LWASS=33
      NSS=NPTW
      PP1=PP
      CSS=C
      OPEN(18,FILE='../temp_files/defaults.input',STATUS='OLD')
      REWIND(18)
      DO 100 I=1,10
      READ(18,*)
  100 CONTINUE
      READ(18,*)TOLSS
      CLOSE(18)
      WRITE(6,'(''STEADY STATE (OR APPROXIMATIONS TO IT)'')')
      WRITE(6,'('' SUPPLIED VIA INPUT FILES IS:'')')
      DO 200 IPTW=1,NPTW
      WRITE(6,'(4X,''TW VARIABLE NUMBER:'',I4)')IPTW
      WRITE(6,'(6X,''STEADY STATE:'',E16.8E2)')USS(IPTW)
  200 CONTINUE
      WRITE(6,'(''NOW CHECK/REFINE THIS BY SOLVING THE'')')
      WRITE(6,'(''STEADY STATE EQUATIONS NUMERICALLY'')')
      WRITE(6,'(''USING THIS AS AN INITIAL GUESS.'')')
      WRITE(6,'(X)')
      CALL HYBRD1(FCNSS,NSS,USS,FVECSS,TOLSS,INFOSS,WASS,LWASS)
      IF (INFOSS.NE.1) THEN
      WRITE(6,'(''FAILURE OF NUMERICAL SOLUTION OF STEADY'')')
      WRITE(6,'(''STATE USING THE MINPACK SUBROUTINE'')')
      WRITE(6,'(''HYBRD1. THE ERROR PARAMETER INFOSS'')')
      WRITE(6,'(''HAS THE VALUE'',I2)')INFOSS
      WRITE(6,'(X)')
      WRITE(6,'(''THE MEANING OF THIS IS:'')')
      WRITE(6,'('' INFOSS=0 improper inputs to HYBRD1'')')
      WRITE(6,'('' INFOSS=2 number of calls to FCN has'')')
      WRITE(6,'(9X,'' reached or exceeded 200*(NPDE+1)'')')
      WRITE(6,'('' INFOSS=3 TOLSS is too small: no further'')')
      WRITE(6,'(9X,'' improvement in the approximate'')')
      WRITE(6,'(9X,'' solution to the steady state'')')
      WRITE(6,'(9X,'' is possible. Note that TOLSS'')')
      WRITE(6,'(9X,'' is set in input_files/defaults.input'')')
      WRITE(6,'('' INFOSS=4 iteration is not making'')')
      WRITE(6,'(9X,'' good progress'')')
      WRITE(6,'(X)')
      WRITE(6,'(''ONE POSSIBLE CAUSE OF THIS ERROR IS A'')')
      WRITE(6,'(''MISTAKE IN THE STEADY STATE FORMULAE'')')
      WRITE(6,'(''IN equations.input, OR IN THE EXTERNAL'')')
      WRITE(6,'(''PROGRAM GENERATING steadystate.input IF'')')
      WRITE(6,'(''THE STEADY STATE IS INPUT VIA THIS FILE.'')')
      WRITE(6,'(X)')
      OPEN(14,FILE='../temp_files/auto_stst.error',STATUS='NEW')
      WRITE(14,'(X)')
      WRITE(14,'(''FAILURE OF NUMERICAL SOLUTION OF STEADY'')')
      WRITE(14,'(''STATE USING THE MINPACK SUBROUTINE'')')
      WRITE(14,'(''HYBRD1. THE ERROR PARAMETER INFOSS'')')
      WRITE(14,'(''HAS THE VALUE'',I2)')INFOSS
      WRITE(14,'(X)')
      WRITE(14,'(''THE MEANING OF THIS IS:'')')
      WRITE(14,'('' INFOSS=0 improper inputs to HYBRD1'')')
      WRITE(14,'('' INFOSS=2 number of calls to FCN has'')')
      WRITE(14,'(9X,'' reached or exceeded 200*(NPDE+1)'')')
      WRITE(14,'('' INFOSS=3 TOLSS is too small: no further'')')
      WRITE(14,'(9X,'' improvement in the approximate'')')
      WRITE(14,'(9X,'' solution to the steady state'')')
      WRITE(14,'(9X,'' is possible. Note that TOLSS'')')
      WRITE(14,'(9X,'' is set in input_files/defaults.input'')')
      WRITE(14,'('' INFOSS=4 iteration is not making'')')
      WRITE(14,'(9X,'' good progress'')')
      WRITE(14,'(X)')
      WRITE(14,'(''ONE POSSIBLE CAUSE OF THIS ERROR IS A'')')
      WRITE(14,'(''MISTAKE IN THE STEADY STATE FORMULAE'')')
      WRITE(14,'(''IN equations.input'')')
      WRITE(14,'(X)')
      CLOSE(14)
      STOP
      ENDIF
      WRITE(6,'(''NUMERICAL SOLUTION FOR STEADY STATE IS:'')')
      DO 210 IPTW=1,NPTW
      WRITE(6,'(4X,''TW VARIABLE NUMBER:'',I4)')IPTW
      WRITE(6,'(6X,''STEADY STATE:'',E16.8E2)')USS(IPTW)
  210 CONTINUE
      RETURN
      END
      SUBROUTINE FCNSS(NPTW,UPTW,DUPTWZ,IFLAG)
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      INTEGER NPTW,IFLAG
      DIMENSION UPTW(NPTW),DUPTWZ(NPTW)
      COMMON / PPCCOM / PP, C
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      DUPTWZ(1)=(UPTW(2))
      DUPTWZ(2)=(-C*UPTW(2)-UPTW(3)*UPTW(1)*UPTW(1)+PARAM(1)*UPTW(
     &1))
      DUPTWZ(3)=((UPTW(3)*UPTW(1)*UPTW(1)+UPTW(3)-PP)/(PARAM(2)+C)
     &)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE HBLIMS(PP,C,IHDRCT,PPHOPF,HBLIM1,HBLIM2,AUTO)
C***********************************************************************
C     THIS SUBROUTINE DEFINES THE SEARCH RANGE FOR A HOPF BIFURCATION 
C     OF THE STEADY STATE (DEFINED BY THE SUBROUTINE stst).
C     IF IHDRCT=0, THEN THE SEARCH FOR THE HOPF BIFURCATION
C     IS DONE WITH WAVE SPEED EQUAL TO THE VALUE C AT WHICH A PERIODIC
C     TRAVELLING WAVE IS SOUGHT, WITH THE CONTROL PARAMETER STARTING
C     AT HBLIM1 AND FINISHING AT HBLIM2. IN THIS CASE THE VARIABLE
C     PPHOPF IS NOT USED AND IS SET TO THE DUMMY VALUE OF ZERO.
C     IF IHDRCT=1, THEN THE SEARCH FOR THE HOPF BIFURCATION
C     IS DONE WITH THE CONTROL PARAMETER EQUAL TO PPHOPF, WITH THE 
C     WAVE SPEED STARTING AT HBLIM1 AND FINISHING AT HBLIM2.
C     NOTE THAT FOR BOTH IHDRCT=0 AND IHDRCT=1, EITHER HBLIM1<HBLIM2 
C     OR HBLIM1>HBLIM2 IS OK; CONTINUATION STARTS AT HBLIM1 AND GOES 
C     IN THE DIRECTION OF HBLIM2. BOTH HBLIM1 AND HBLIM2 MUST BE SUCH 
C     THAT THE STEADY STATE EXISTS.
C     NOTE THAT: (1) VALUES OF HBLIM1 AND HBLIM2 THAT ARE CLOSER
C                    TO ONE ANOTHER (AND THUS TO THE ACTUAL HOPF 
C		     BIFURCATION POINT) WILL SPEED UP EXECUTION. 
C                (2) HBLIM1 AND HBLIM2 CAN DEPEND ON PP AND C, WHICH 
C		     ENABLES DIFFERENT PARTS OF THE PP-C PLANE TO BE 
C		     ACCESSED FROM DIFFERENT PARTS OF THE HOPF 
C		     BIFURCATION LOCUS/LOCI.
C                (3) THE SETTING iwave=0 (SET IN constants.input) IS
C		     ONLY PERMISSIBLE IF IHDRCT=0 THEN HBLIM2 IS
C                    NOT USED; IT IS REPLACED BY THE VALUE PP OF 
C		     THE CONTROL PARAMETER AT WHICH A PERIODIC 
C		     TRAVELLING WAVE IS SOUGHT. (THIS IS THE ONLY
C		     DIFFERENCE BETWEEN iwave=0 AND iwave=1).
C     IF IHDRCT=2, THEN NO SEARCH IS DONE FOR A HOPF BIFURCATION. 
C     INSTEAD, THE STARTING POINT FOR LOCATING PERIODIC TRAVELLING
C     WAVE SOLUTIONS IS THE FILE ptwsoln.input IN THE RELEVANT INPUT
C     SUBDIRECTORY. THIS FILE CONTAINS A LIST OF TRAVELLING WAVE
C     COORDINATE VALUES AND THE CORRESPONDING TRAVELLING WAVE 
C     VARIABLES FOR A PERIODIC TRAVELLING WAVE SOLUTION. THE 
C     SOLUTION SHOULD BE GIVEN OVER ONE PERIOD AND IT IS VERY
C     IMPORTANT THAT THE FIRST AND LAST LINES ARE ONE PERIOD 
C     APART, WITH THE SAME VALUES OF THE TRAVELLING WAVE VARIABLES.
C     IN THIS CASE, HBLIM1 AND HBLIM2 CONTAIN THE CORRESPONDING 
C     VALUE OF THE CONTROL PARAMETER AND WAVE SPEED.
C     INPUTS: PP: THE CONTROL PARAMETER FOR WHICH THE PERIODIC 
C                 TRAVELLING WAVE IS REQUIRED.
C             C: THE WAVE SPEED 
C             AUTO: .TRUE. IF THE SUBROUTINE IS CALLED AS PART OF
C	            AN AUTO RUN, .FALSE. OTHERWISE. THIS AFFECTS
C	            THE WAY IN WHICH ERROR MESSAGES ARE PROCESSED.
C     OUTPUTS: IHDRCT: 0 IF THE HOPF BIFURCATION IS SOUGHT AT
C		       FIXED WAVE SPEED, WITH THE CONTROL PARAMETER
C		       VARYING, AND 1 IN THE OPPOSITE CASE.
C              PPHOPF: IF IHDRCT=1, THIS SPECIFIES THE FIXED 
C	               VALUE OF THE CONTROL PARAMETER. 
C                      IF IHDRCT=0 OR 2, IT IS SET TO THE DUMMY 
C                      VALUE OF ZERO.
C              HBLIM1, HBLIM2: IF IHDRCT=0, THESE ARE THE START 
C                                AND END POINTS OF THE CONTROL 
C                                PARAMETER FOR NUMERICAL CONTINUATION, 
C                                SEARCHING FOR A HOPF BIFURCATION IN 
C			         THE TRAVELLING WAVE EQUATIONS.
C                              IF IHDRCT=1, THESE ARE THE START 
C                                AND END POINTS OF THE CONTROL 
C                                PARAMETER FOR NUMERICAL CONTINUATION, 
C                                SEARCHING FOR A HOPF BIFURCATION IN 
C			         THE TRAVELLING WAVE EQUATIONS.
C                              IF IHDRCT=2, THESE ARE THE VALUES OF  
C                                THE CONTROL PARAMETER (HBLIM1) AND 
C                                WAVE SPEED (HBLIM2) CORRESPONDING 
C			         TO THE PERIODIC TRAVELLING WAVE 
C                                SOLUTION IN THE FILE ptwsoln.input.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      LOGICAL EXISTS, AUTO
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      EXISTS=.TRUE.
      IHDRCT=0
      PPHOPF=(0.0D0)
      HBLIM1=(3.8D0)
      HBLIM2=(2.001D0*PARAM(1))
      IF (.NOT.EXISTS) THEN
      IF (AUTO) THEN
      WRITE(6,'(''Problem in subroutine'')')
      WRITE(6,'(''hblims in equations.f'')')
      WRITE(6,'(''Hopf bifn search limits not defined'')')
      OPEN(14,FILE='../temp_files/auto_stst.error',STATUS='NEW')
      WRITE(14,'(''Hopf bifn search limits not defined'')')
      CLOSE(14)
      STOP
      ELSE
      CALL GINFO(INFO)
      OPEN(66,FILE='../temp_files/message.txt',STATUS='NEW')
      WRITE(66,'(''ERROR:'')')
      WRITE(66,'(''in subroutine hblims in equations.f'')')
      WRITE(66,'(''Hopf bifn search limits not defined'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
      ENDIF
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE WFORN(Z,X,N,ND,M,C)
C     THIS SUBROUTINE IS BASED ON CODE WRITTEN BY BENGT FORNBERG,
C     WHICH IS LISTED IN THE ARTICLE "CALCULATION OF WEIGHTS IN 
C     FINITE DIFFERENCE FORMULAS" BY B. FORNBERG, SIAM REVIEW 
C     40: 685-691 (1998).
C---  
C---  INPUT PARAMETERS
C---  Z LOCATION WHERE APPROXIMATIONS ARE TO BE ACCURATE,
C---  X(0:ND) GRID POINT LOCATIONS, FOUND IN X(0:N)
C---  N ONE LESS THAN TOTAL NUMBER OF GRID POINTS; N MUST
C---  NOT EXCEED THE PARAMETER ND BELOW,
C---  ND DIMENSION OF X- AND C-ARRAYS IN CALLING PROGRAM
C---  X(0:ND) AND C(0:ND,0:M), RESPECTIVELY,
C---  M HIGHEST DERIVATIVE FOR WHICH WEIGHTS ARE SOUGHT,
C---  OUTPUT PARAMETER
C---  C(0:ND,0:M) WEIGHTS AT GRID LOCATIONS X(0:N) FOR
C---  DERIVATIVES OF ORDER 0:M, FOUND IN C(0:N,0:M)
C---  
      IMPLICIT REAL*8 ( A - H, K, O - Z)
      INTEGER I,J,IK,M,N,ND
      DIMENSION X(0:ND),C(0:ND,0:M)
      C1 = 1.0D0
      C4 = X(0)-Z
      DO 10 IK=0,M
         DO 11 J=0,N
            C(J,IK) = 0.0D0
 11      CONTINUE
 10   CONTINUE
      C(0,0) = 1.0D0
      DO 50 I=1,N
         MN = MIN(I,M)
         C2 = 1.0D0
         C5 = C4
         C4 = X(I)-Z
         DO 40 J=0,I-1
            C3 = X(I)-X(J)
            C2 = C2*C3
            IF (J.EQ.(I-1)) THEN
               DO 20 IK=MN,1,-1
                  C(I,IK) = C1*(IK*C(I-1,IK-1)-C5*C(I-1,IK))/C2
 20            CONTINUE
               C(I,0) = -C1*C5*C(I-1,0)/C2
            ENDIF
            DO 30 IK=MN,1,-1
               C(J,IK) = (C4*C(J,IK)-IK*C(J,IK-1))/C3
 30         CONTINUE
            C(J,0) = C4*C(J,0)/C3
 40      CONTINUE
         C1 = C2
 50   CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      REAL*8 FUNCTION ZCNVRT(I,NPTS,Z,PERIOD)
C     THIS SUBROUTINE RETURNS THE VALUE OF THE TRAVELLING WAVE
C     COORDINATE CORRESPONDING TO GRID POINT I, WHICH MAY BE OUTSIDE
C     THE RANGE 1:NPTS. AN APPROPRIATE MULTIPLE OF THE PERIOD IS
C     ADDED OR SUBTRACTED IN THAT CASE.
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      DIMENSION Z(NPTS)
      INTEGER I,NPTS,J,IGRID
      IF (I.GT.0) THEN
        J=(I-1)/NPTS
      ELSE
        J=-1+((I-1)/NPTS)
      ENDIF
      IGRID=I-J*NPTS
      ZCNVRT=Z(IGRID)+J*PERIOD
      RETURN
      END
C-----------------------------------------------------------------------
      INTEGER FUNCTION ICNVRT(I,NPTS)
C     THIS SUBROUTINE DEALS WITH THE FACT THAT THE DOMAIN IS PERIODIC,
C     AND WRAPS THE MATRIX INDEX AROUND APPROPRIATELY.
C     IT MAPS: I=-NPTS+1,...,0 -> ICNVRT=1,...,NPTS
C              I=1,...,NPTS -> ICNVRT=1,...,NPTS
C              I=NPTS+1,...,2*NPTS -> ICNVRT=1,...,NPTS
C              I=2*NPTS+1,...,3*NPTS -> ICNVRT=1,...,NPTS
C              ETC.
      IMPLICIT REAL*8 ( A - H, K, O - Z)
      INTEGER I,J,NPTS
      IF (I.GT.0) THEN
        J=(I-1)/NPTS
      ELSE
        J=-1+((I-1)/NPTS)
      ENDIF
      ICNVRT=I-J*NPTS
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE DISCEF(NPDE,NPTW,NPTS,PP,C,Z,UPTWIN,PERIOD,AMATRX,
     &UPTW)
C***********************************************************************
C     THIS SUBROUTINE SPECIFIES THE MATRIX GIVEN BY DISCRETISING THE 
C     EIGENFUNCTION EQUATIONS (GIVEN BY LINEARISING THE GOVERNING 
C     PARTIAL DIFFERENTIAL EQUATIONS ABOUT THE PERIODIC TRAVELLING WAVE 
C     SOLUTION) IN THE CASE OF PERIODIC BOUNDARY CONDITIONS, I.E. IN THE 
C     CASE OF THE EIGENFUNCTION BEING PERIODIC OVER ONE PERIOD OF THE 
C     TRAVELLING WAVE. IF EACH OF THE GOVERNING PDES HAS EXACTLY ONE 
C     TIME DERIVATIVE THEN THE EIGENVALUE PROBLEM IS OF STANDARD TYPE.
C     HOWEVER IF ONE OR MORE OF THE EQUATIONS JUST INVOLVES
C     SPATIAL DERIVATIONS, THE EIGENVALUE PROBLEM BECOMES OF 
C     GENERALISED TYPE AND THE SUBROUTINE DISCEG IS NEEDED, AS WELL
C     AS DISCEF. EITHER WAY, THE DISCRETISED EIGENVALUE PROBLEM 
C     HAS THE FORM A*U=LAMBDA*B*U, WHERE A AND B ARE NEQN BY NEQN 
C     MATRICES, AND U IS THE SOLUTION VECTOR (OF DIMENSION NEQN). 
C     (IN THE CASE OF A STANDARD EIGENVALUE PROBLEM, B IS THE IDENTITY
C     MATRIX). THIS SUBROUTINE CALCULATES THE MATRIX A.
C     INPUTS: NPDE: THE NUMBER OF PDE VARIABLES
C             NPTW: THE NUMBER OF PTW VARIABLES
C             NPTS: THE NUMBER OF POINTS USED TO DISCRETISE THE
C                   TRAVELLING WAVE COORDINATE
C             PP: THE CONTROL PARAMETER
C             C: THE WAVE SPEED
C             Z: AN ARRAY OF DIMENSION NPTS, GIVING THE VALUES OF 
C                Z IN THE DISCRETE GRID. NOTE THAT THIS IS SET UP 
C                WITHOUT REPETITION OF THE END VALUES, SO THAT 
C                "Z(0)" WOULD BE THE SAME AS Z(NPTS) AND 
C                "Z(NPTS+1)" WOULD BE THE SAME AS Z(1).
C             UPTWIN: AN ARRAY OF DIMENSION (NPTW,NPTS): THE DISCRETISED 
C                     PERIODIC TRAVELLING WAVE SOLUTION.
C             PERIOD: THE PERIOD OF THE PERIODIC TRAVELLING WAVE 
C                     SOLUTION.
C     OUTPUTS: AMATRX: AN ARRAY OF DIMENSION (NPDE*NPTS,NPDE*NPTS): THE 
C              MATRIX A
C     WORKSPACE: UPTW: AN ARRAY OF DIMENSION NPTW
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      DIMENSION Z(NPTS),AMATRX(NPDE*NPTS,NPDE*NPTS)
      DIMENSION UPTWIN(NPTW,NPTS),UPTW(NPTW)
      INTEGER NPDE,NPTW,NPTS,IPOINT,JPOINT,I,J
      INTEGER NFORN,NDFORN,MFORN
      DIMENSION XFORN(0:2)
      DIMENSION CMATRX(0:2,0:2)
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      DO 301 I=1,NPDE*NPTS
      DO 302 J=1,NPDE*NPTS
      AMATRX(I,J)=0.0D0
  302 CONTINUE
  301 CONTINUE
      NFORN=2
      NDFORN=NFORN
      MFORN=2
      DO 100 IPOINT=1,NPTS
      DO 303 I=1,NPTW
      UPTW(I)=UPTWIN(I,IPOINT)
  303 CONTINUE
      ZFORN=Z(IPOINT)
      DO 150 J=-1,1
      XFORN(J+1)=ZCNVRT(IPOINT+J,NPTS,Z,PERIOD)
  150 CONTINUE
      CALL WFORN(ZFORN,XFORN,NFORN,NDFORN,MFORN,CMATRX)
      AMATRX(IPOINT,IPOINT)=AMATRX(IPOINT,IPOINT)+(2.0D0*UPTW(1)*U
     &PTW(3)-PARAM(1))
      AMATRX(IPOINT,NPTS+IPOINT)=AMATRX(IPOINT,NPTS+IPOINT)+(UPTW(
     &1)**2)
      AMATRX(IPOINT+NPTS,IPOINT)=AMATRX(IPOINT+NPTS,IPOINT)+(-2.0D
     &0*UPTW(3)*UPTW(1))
      AMATRX(IPOINT+NPTS,NPTS+IPOINT)=AMATRX(IPOINT+NPTS,NPTS+IPOI
     &NT)+(-1.0D0-UPTW(1)**2)
      DO 200 JPOINT=-1,+1
      AMATRX(IPOINT,ICNVRT(IPOINT+JPOINT,NPTS))=AMATRX(IPOINT,ICNV
     &RT(IPOINT+JPOINT,NPTS))+CMATRX(JPOINT+1,1)*(C)
      AMATRX(IPOINT,ICNVRT(IPOINT+JPOINT,NPTS))=AMATRX(IPOINT,ICNV
     &RT(IPOINT+JPOINT,NPTS))+CMATRX(JPOINT+1,2)*(1.0D0)
      AMATRX(IPOINT+NPTS,NPTS+ICNVRT(IPOINT+JPOINT,NPTS))=AMATRX(I
     &POINT+NPTS,NPTS+ICNVRT(IPOINT+JPOINT,NPTS))+CMATRX(JPOINT+1,
     &1)*(C)
      AMATRX(IPOINT+NPTS,NPTS+ICNVRT(IPOINT+JPOINT,NPTS))=AMATRX(I
     &POINT+NPTS,NPTS+ICNVRT(IPOINT+JPOINT,NPTS))+CMATRX(JPOINT+1,
     &1)*(PARAM(2))
  200 CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE DISCEG(NPDE,NPTS,BMATRX)
C***********************************************************************
C     THIS SUBROUTINE IS ONLY INCLUDED IN equations.f IF THE PROBLEM HAS
C     ONE OR MORE EQUATIONS WITHOUT A TIME DERIVATIVE, WHICH CAUSES THE
C     EIGENVALUE PROBLEM TO BE OF GENERALISED TYPE. THIS MEANS THAT THE
C     PROBLEM HAS THE FORM A*U=LAMBDA*B*U WHERE B HAS 1 AT SOME DIAGONAL
C     ELEMENTS AND 0 AT OTHERS. THIS SUBROUTINE DEFINES THE MATRIX B.
C     INPUTS: NPDE: THE NUMBER OF PDE VARIABLES
C             NPTS: THE NUMBER OF POINTS USED TO DISCRETISE THE
C                   TRAVELLING WAVE COORDINATE
C     OUTPUTS: BMATRX: AN ARRAY OF DIMENSION (NPDE*NPTS,NPDE*NPTS): THE
C                      MATRIX B.
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      INTEGER NPDE,NPTS,I,J
      DIMENSION BMATRX(NPDE*NPTS,NPDE*NPTS)
      DO 100 I=1,NPDE*NPTS
      DO 110 J=1,NPDE*NPTS
      BMATRX(I,J)=0.0D0
  110 CONTINUE
  100 CONTINUE
      J=NPTS*0
      DO 201 I=1,NPTS
      BMATRX(I+J,I+J)=1.0D0
 201  CONTINUE
      J=NPTS*1
      DO 202 I=1,NPTS
      BMATRX(I+J,I+J)=1.0D0
 202  CONTINUE
      RETURN
      END
      SUBROUTINE GETAG(AG)
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      CHARACTER*1 AG
      AG='n'
      RETURN
      END
C----------------------------------------------------------------
      SUBROUTINE PDE2TW(NPDE,NPTW,NPTS,Z,UPDEIN,IPOINT,UPTW,
     &UPDE)
C***********************************************************************
C     THIS SUBROUTINE PROVIDES THE CONVERSION BETWEEN THE PERIODIC 
C     TRAVELLING WAVE AND PARTIAL DIFFERENTIAL EQUATION VARIABLES. 
C     TYPICALLY THE PERIODIC TRAVELLING WAVE VARIABLES WILL EITHER 
C     BE EQUAL TO THE PDE VARIABLES, OR GIVEN BY DISCRETE APPROXIMATIONS 
C     TO THEIR DERIVATIVES. 
C     INPUTS: NPDE: THE NUMBER OF PDE VARIABLES
C             NPTW: THE NUMBER OF PTW VARIABLES
C             NPTS: THE NUMBER OF POINTS USED TO DISCRETISE THE
C                   TRAVELLING WAVE COORDINATE
C             Z: AN ARRAY OF DIMENSION NPTS, GIVING THE TRAVELLING
C                WAVE COORDINATE VALUES AT THE GRID POINTS
C             UPDEIN: AN ARRAY OF DIMENSION (NPDE,NPTS), GIVING THE 
C                     VALUES OF THE PDE VARIABLES AT THE GRID POINTS
C             IPOINT: THE GRID POINT AT WHICH THE PTW VARIABLES ARE 
C                     REQUIRED 
C     OUTPUTS: UPTW: AN ARRAY OF DIMENSION NPTW, GIVING THE VALUES OF 
C                    THE PTW VARIABLES AT THE SPECIFIED GRID POINT.
C     WORKSPACE: UPDE: AN ARRAY OF DIMENSION NPDE
C***********************************************************************
      IMPLICIT REAL*8 ( A - H, K, O - Z )
      INTEGER NPDE,NPTW,NPTS,IPOINT,IPDE
      DIMENSION Z(NPTS),UPTW(NPTW)
      DIMENSION UPDE(NPDE),UPDEIN(NPDE,NPTS)
C     FIRST CALCULATE A MATRIX CONTAINING ALL OF THE SPATIAL DERIVATIVES
C     THAT MIGHT BE NEEDED AT THE SPECIFIED GRID POINT, FOR ALL OF THE 
C     PDE VARIABLES. MANY OF THESE WILL NOT BE NEEDED, BUT IT IS EASIEST
C     JUST TO CALCULATE ALL OF THEM, WITH VERY LITTLE EXTRA 
C     RUN TIME.
      INTEGER NFORN,NDFORN,MFORN
      DIMENSION XFORN(0:2)
      DIMENSION CMATRX(0:2,0:2)
      DIMENSION DUPDE(2,2)
      DIMENSION PARAM(2)
      PARAM(1)=0.45D0
      PARAM(2)=182.5D0
      DO 301 IPDE=1,2
      UPDE(IPDE)=UPDEIN(IPDE,IPOINT)
  301 CONTINUE
      NFORN=2
      NDFORN=NFORN
      MFORN=2
      ZFORN=Z(IPOINT)
      DO 150 J=-1,1
      XFORN(J+1)=ZCNVRT(IPOINT+J,NPTS,Z,PERIOD)
  150 CONTINUE
      CALL WFORN(ZFORN,XFORN,NFORN,NDFORN,MFORN,CMATRX)
      DO 200 IPDE=1,2
      DO 210 IDERIV=1,2
      DUPDE(IPDE,IDERIV)=0.0D0
      DO 220 J=-1,1
      DUPDE(IPDE,IDERIV)=DUPDE(IPDE,IDERIV)+CMATRX(J+1,IDERIV)*UPD
     &EIN(IPDE,ICNVRT(IPOINT+J,NPTS))
  220 CONTINUE
  210 CONTINUE
  200 CONTINUE
      UPTW(1)=(UPDE(1))
      UPTW(2)=(DUPDE(1,1))
      UPTW(3)=(UPDE(2))
      RETURN
      END
C-----END OF FILE-----
