C+    bd_prepare.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES FOR THE
C+    BIFURCATION DIAGRAM CALCULATIONS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      OPEN(12,FILE='../temp_files/arguments.data'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)ICP
      CLOSE(12)
C-----
      OPEN(13,FILE='../temp_files/bd.range'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX
      READ(13,*)CMIN,CMAX
      CLOSE(13)
C-----
      IF (ICP.EQ.1) THEN
         DSFCTR=1.0D0
      ELSE
         DSFCTR=(ABS(CMAX)+ABS(CMIN))/(ABS(PPMAX)+ABS(PPMIN))
      ENDIF
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
      READ(12,*)
      READ(12,*)DS1,DSMIN1,DSMAX1
      READ(12,*)DS2,DSMIN2,DSMAX2
      CLOSE(12)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMX1,IDUMMY,NMX2
      READ(11,*)A0,A1
      READ(11,*)EPSL,EPSU,EPSS
      CLOSE(11)
C-----
      DS1=DS1*DSFCTR
      DSMIN1=DSMIN1*DSFCTR
      DSMAX1=DSMAX1*DSFCTR
C     Note: the input ds value are for pp. Multiplying by dsfctr has 
C           the effect of rescaling appropriately if continuation is 
C           actually done with c as the continuation parameter.
C-----
      IPS=1
      IRS=0
      ILP=0
      NICP=6
      IF (ICP.EQ.1) THEN
         ICP1=1
         ICP2=2
      ELSE
         ICP1=2
         ICP2=1
      ENDIF
C     Note: icp2 is a dummy value in this case. It doesn't change during
C           the continuation, and is included just to make the number of
C           continuation parameters the same as in run file 88 (where it
C           is replaced by the period).
      ICP3=3
      ICP4=4
      ICP5=5
      ICP6=6
      NCOL=4
      IAD=3
      ISP=0
      ISW=1
      IPLT=0
      NBC=0
      NINT=0
      IF (ICP.EQ.1) THEN
         RL0=PPMIN
         RL1=PPMAX
      ELSE
         RL0=CMIN
         RL1=CMAX
      ENDIF
      NPR1=NMX1
      NPR2=NMX2
      MXBF=10
      IID=2
      ITMX=8
      ITNW=5
      NWTN=3
      JAC=0
      IADS=1
C-----
      OPEN(13,FILE='r.ptw.77'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(13,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX1,RL0,RL1,A0,A1
      WRITE(13,'(I8,6I3)')NPR1,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')ABS(DS1),DSMIN1,DSMAX1,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(13)
C-----
      IPS=2
      IRS=2
      ILP=1
C     Note that detection of folds is requested
      NICP=6
      ICP1=ICP
      ICP2=11
      ICP3=3
      ICP4=4
      ICP5=5
      ICP6=6
C-----
      OPEN(13,FILE='r.ptw.88'
     &,STATUS='NEW')
      WRITE(13,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(13,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(13,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(13,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
      WRITE(13,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(13,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(13,'(3E16.8E2,I3)')ABS(DS2),DSMIN2,DSMAX2,IADS
      WRITE(13,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(13)
C-----
C     Now write r files for use when starting solution is 
C       given in a file. Two files are needed, which are
C       identical except for the sign of ds: these 
C       correspond to different continuation directions.
      IRS=1
      OPEN(14,FILE='r.ptw.file1'
     &,STATUS='NEW')
      WRITE(14,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(14,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(14,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(14,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
      WRITE(14,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(14,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(14,'(3E16.8E2,I3)')ABS(DS2),DSMIN2,DSMAX2,IADS
      WRITE(14,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(14)
      OPEN(15,FILE='r.ptw.file2'
     &,STATUS='NEW')
      WRITE(15,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(15,'(7I8)')NICP,ICP1,ICP2,ICP3,ICP4,ICP5,ICP6
      WRITE(15,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(15,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
      WRITE(15,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(15,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(15,'(3E16.8E2,I3)')(-ABS(DS2)),DSMIN2,DSMAX2,IADS
      WRITE(15,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(15)
C-----
      STOP
      END
