C+    bdfiletest.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    WHEN AN OPTIONAL file= ARGUMENT IS USED IN THE
C+    bifurcation_diagram COMMAND, THIS PROGRAM CHECKS 
C+    WHETHER THE VALUE OF THE FIXED PARAMETER (EITHER
C+    THE CONTROL PARAMETER OR THE WAVE SPEED) IS
C+    THE SAME IN THE COMMAND LINE AND THE .params FILE
C++
C     NOTE: this program is run before the info output
C           system is set up.
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*10 APPORC(2)
      DIMENSION PARAM(2),PARMIN(2),PARMAX(2)
C-----
      OPEN(12,FILE='../temp_files/bdfiletest.input1'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)PARAM(1),PARAM(2)
      CLOSE(12)
C-----
      OPEN(13,FILE='../temp_files/bdfiletest.input2'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)ICP
      READ(13,*)PPORC
      READ(13,*)IFILE
      CLOSE(13)
      IF (ICP.EQ.1) THEN
         IPARAM=2
      ELSE
         IPARAM=1
      ENDIF
C-----
      OPEN(14,FILE='../temp_files/bdfiletest.input3'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)PARMIN(1),PARMAX(1)
      READ(14,*)PARMIN(2),PARMAX(2)
      CLOSE(14)
C-----
      PERROR=ABS(100.0D0*((PARAM(IPARAM)-PPORC))
     &     /(PARMAX(IPARAM)-PARMIN(IPARAM)))
      IF (PERROR.GT.(0.1D0)) THEN
C        Note that the choice of 0.1% as an error 
C             threshold is arbitrary
         IERROR=1
      ELSE
         IERROR=0        
      ENDIF
      OPEN(16,FILE='../temp_files/bdfiletest.output'
     &,STATUS='NEW')
      WRITE(16,9000)IERROR
      CLOSE(16)
C-----
      STOP
 9000 FORMAT(I1)
      END
