C+    detect_speed_test.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CHECKS WHETHER AUTO HAS FOUND A PERIODIC TRAVELLING
C+    WAVE SOLUTION AT THE REQUIRED VALUE OF THE WAVE SPEED. IT IS 
C+    ONLY USED FOR INDIRECT OR FILE WAVE SEARCH METHODS.
C+    IF NOT, idtect IS GIVEN A VALUE AS FOLLOWS:
C+               idtect=51,52: AUTO FINISHED CONTINUATION WITHOUT ERROR
C+                             BUT BEFORE REACHING THE REQUESTED VALUE
C+                             OF THE WAVE SPEED. CODE 51 MEANS
C+                             THAT THE CONTINUATION SUCCESSFULLY COVERED 
C+                             THE WHOLE OF THE SPECIFIED RANGE OF 
C+                             WAVE SPEED VALUES; CODE 52 MEANS
C+                             THAT ONLY PART OF THE SPECIFIED RANGE OF
C+                             WAVE SPEED VALUES WAS COVERED. THE
C+                             LATTER OUTCOME INDICATES THAT EITHER THE
C+                             RELEVANT DS VALUES SHOULD BE INCREASED, 
C+                             OR LARGER NMX VALUES SHOULD BE USED.
C+               idtect=5: CONVERGENCE PROBLEM IN AUTO.
C+    IF THE REQUIRED PERIODIC TRAVELLING WAVE SOLUTION IS FOUND, idtect
C+    IS SET TO ZERO.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*1 ADTECT
      CALL GINFO(INFO)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
C     First read in the required value of c
      OPEN(11,FILE='../temp_files/control_parameters.data'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)CTRGT
      CLOSE(11)
C     Now read in the auto output file
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 600 I=1,12
         READ(12,*,END=103)
 600  CONTINUE
      READ(12,*,END=103)IDUMMY,IPT,ITY,ILAB,C,RNORM
      DO 100 I=1,NMXPTW+1
         IF (ITY.EQ.(-9)) THEN
            ADTECT='n'
            IDTECT=5
            GOTO 102
         ENDIF
         READ(12,*,END=101)IDUMMY,IPT,ITY,ILAB,C,RNORM
 100  CONTINUE
      CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: END OF LOOP 100 IN detect_speed_test.f'')')
      CLOSE(66)
      ADTECT='n'
      WRITE(6,9000)ADTECT
      CALL ISTOP(INFO)
C-----
 101  CONTINUE
C     auto converged: now check whether the final
C                     value of c is the target value
      OPEN(16,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(16)
      READ(16,*)
      READ(16,*)CATOL,CRTOL
      CLOSE(16)
      IF (ABS(CATOL).GT.ABS(0.01D0*CTRGT)) THEN
         OPEN(69,FILE='../temp_files/detect.warning1'
     &,STATUS='NEW')
         WRITE(69,'(/,
     &''WARNING: THE VALUE OF controlatol IS RATHER LARGE'',/,
     &''         COMPARED TO THE WAVE SPEED VALUE.'',/,
     &''         THIS MAY BE APPROPRIATE, BUT IT MIGHT'',/,
     &''         ALSO INDICATE THAT controlatol SHOULD'',/,
     &''         BE REDUCED IN defaults.input''
     &,/)')
         CLOSE(69)
      ENDIF
      CTOL=ABS(CRTOL*CTRGT)+ABS(CATOL)
      IF (ABS(C-CTRGT).LT.CTOL) THEN
         ADTECT='y'
         IDTECT=0
         OPEN(18,FILE='data_files/ptw.label'
     &,STATUS='NEW')
         WRITE(18,'(I8)')ILAB
C        FOR POSS USE IN PERIOD CONTOUR OR FOLD LOCUS CONTINUATION
C        (THIS IS INCLUDED BECAUSE RUN 44 MIGHT BE THE RUN
C        IN WHICH THE PTW IS DETECTED. IF NOT, THE FILE
C        data_files/ptw.label WILL BE OVERWRITTEN LATER).
         CLOSE(18)
      ELSE
         ADTECT='n'
         OPEN(17,FILE='r.ptw.44'
     &,STATUS='OLD')
         REWIND(17)
         READ(17,*)
         READ(17,*)
         READ(17,*)
         READ(17,*)IDUMMY,RL0,RL1
         CLOSE(17)
         CTST1=RL0*(1+CRTOL)+CATOL
         CTST2=RL1*(1-CRTOL)-CATOL
C        Note: the purpose of CTST1 and CTST2 is to add a little wiggle
C           room to the min/max values of c, to allow for auto classifying
C           that the end point has been reached when in fact c falls just
C           short of the end point.
         IF ((C.LE.CTST1).OR.(C.GE.CTST2)) THEN
            IDTECT=51
         ELSE
            IDTECT=52
         ENDIF
      ENDIF
C-----
 102  CLOSE(12)
      CALL DWARN(IPT)
      OPEN(14,FILE='../temp_files/outcome.data'
     &,STATUS='NEW')
      WRITE(14,9001)IDTECT
      CLOSE(14)
      WRITE(6,9000)ADTECT
C     screen output not "message": feeds into a pipe
      CALL ISTOP(INFO)
C-----
 103  CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: FILE 12 HAS NO REAL OUTPUT'',
     &     '' LINES in detect_speed_test.f'')')
      CLOSE(66)
      ADTECT='n'
      WRITE(6,9000)ADTECT
      CALL ISTOP(INFO)
 9000 FORMAT(A1)
 9001 FORMAT(I2)
      END

      SUBROUTINE DWARN(IPT)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL DOWARN
      CHARACTER*5 WORD1
      CHARACTER*28 WORD2
      CHARACTER*8 WORD3
      CHARACTER*25 ATYPE
C-----
C      ATYPE='HOPF BIFURCATION POINT.  '
      ATYPE='PERIODIC TRAVELLING WAVE.'
C      ATYPE='FOLD POINT.              '
C      ATYPE='ECKHAUS POINT.           '
C      ATYPE='HOPF POINT.              '
C      ATYPE='SOLN OF THE RIGHT PERIOD.'
C-----
      OPEN(23,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(23)
      DO 230 I230=1,11
         READ(23,*)
 230  CONTINUE
      READ(23,*)NWARN1,NWARN2
      CLOSE(23)
      IPT=ABS(IPT)
      DOWARN=.FALSE.
      IF (IPT.LT.NWARN1) THEN
         DOWARN=.TRUE.
         WORD1='SMALL'
         WORD2='JUMPING OVER BIFURCATION PTS'
         WORD3='DECREASE'
      ENDIF
      IF (IPT.GT.NWARN2) THEN
         DOWARN=.TRUE.
         WORD1='LARGE'
         WORD2='UNNECESSARILY LONG RUN TIMES'
         WORD3='INCREASE'
      ENDIF
      IF (DOWARN) THEN
         OPEN(66,FILE='../temp_files/detect.warning'
     &,STATUS='NEW')
         WRITE(66,9000)WORD1,IPT,ATYPE,WORD2,WORD3
         CLOSE(66)
      ENDIF
      RETURN
 9000 FORMAT(/,'WARNING: A RATHER ',A5,' NUMBER OF',
     &     ' CONTINUATION STEPS (=',I5,')',/,
     &     'WAS TAKEN LOOKING FOR THE ',
     &     A25,/,'TO AVOID ',A28,' IT MIGHT BE',
     &     ' HELPFUL TO',/,A8,' THE RELEVANT',
     &     ' ds, dsmin AND dsmax',
     &     ' IN constants.input.',/)
      END
