C+    extractptw.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE AUTO OUTPUT FILES FROM A RUN CALCULATING
C+    A PERIODIC TRAVELLING WAVE, AND WRITES MORE USER-FRIENDLY DATA FILES
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      PARAMETER(MPTPTW=10000)
      PARAMETER(NPTW=3)
C     NOTE: these two parameter statements are rewritten by 
C     extractptw_prepare.script, which is a script file created by
C     extractptw_prepare.f
      DIMENSION IARRAY(9)
      DIMENSION ZPTW(MPTPTW),UPTW(NPTW,MPTPTW)
      DIMENSION UPTW0(NPTW),FPTW0(NPTW)
      CALL GINFO(INFO)
      OPEN(12,FILE='q.ptwsoln'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='data_files/ptw.soln'
     &,STATUS='NEW')
      OPEN(14,FILE='data_files/ptw.params'
     &,STATUS='NEW')
      READ(12,*,END=400)(IARRAY(J),J=1,9)
      NPTPTW=IARRAY(7)
      IF (NPTPTW.GT.MPTPTW) THEN
         OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
         WRITE(66,'(''ERROR: nptptw > mptptw'')')
         CLOSE(66)
         CALL IOUT(INFO,'error')
         CALL ISTOP(INFO)
      ENDIF
      DO 300 ILOOP3=1,IARRAY(7)
         READ(12,*,END=400)
     &        ZPTW(ILOOP3),(UPTW(IPTW,ILOOP3),IPTW=1,NPTW)
         WRITE(13,9000)
     &        ZPTW(ILOOP3),(UPTW(IPTW,ILOOP3),IPTW=1,NPTW)
 300  CONTINUE
      READ(12,*,END=400)IDUMMY
      DO 301 ILOOP4=1,(IARRAY(7)+1)
         READ(12,*,END=400)DUMMY
 301  CONTINUE
      READ(12,*,END=400)PP,CPAR
      READ(12,*,END=400)DUMMY1,DUMMY2,DUMMY3,PERIOD
      WRITE(14,9002)PP,CPAR,PERIOD,NPTPTW
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
C********************************************************************
C     THE REST OF THIS PROGRAM (UP TO THE NEXT ROW OF STARS) 
C     WRITES A DATA FILE WITH THE EIGENFUNCTION CORRESPONDIeNG 
C     TO THE ZERO EIGENVALUE. I WROTE THIS FOR USE IN THE DETECTION
C     OF CHANGES IN PTW STABILITY OF ECKHAUS TYPE, WRITING THE
C     DATA FILE WHENEVER THIS PROGRAM WAS RUN FOR CONVENIENCE. 
C     HOWEVER, I LATER DECIDED TO ESTIMATE THIS EIGENFUNCTION FROM
C     THE RESULTS OF THE DISCRETE EIGENVALUE CALCULATION, DONE IN
C     ../gammazero/evaluecalc.f. THEREFORE THIS PART OF THE PROGRAM
C     IS COMMENTED OUT.
C********************************************************************
C      ZERO=0.0D0
C      OPEN(15,FILE='data_files/efn_at_zero.dat'
C     &,STATUS='NEW')
C      RNORM=0.0D0
C      DO 350 J=1,2
C         DO 404 I=1,NPTPTW
C            DO 401 IPTW=1,NPTW
C               UPTW0(IPTW)=UPTW(IPTW,I)
C 401        CONTINUE
C            CALL TWEQS(NPTW,PP,C,UPTW0,FPTW0)
C            IF (J.EQ.1) THEN
C               IF (I.EQ.1) THEN
C                  DZ=(ZPTW(2)-ZPTW(1))/2
C               ENDIF
C               IF (I.EQ.NPTPTW) THEN
C                  DZ=(ZPTW(NPTPTW)-ZPTW(NPTPTW-1))/2
C               ENDIF
C               IF ((I.GT.1).AND.(I.LT.NPTPTW)) THEN
C                  DZ=(ZPTW(I+1)-ZPTW(I-1))/2
C               ENDIF
C               DO 402 IPTW=1,NPTW
C                  RNORM=RNORM+(FPTW0(IPTW)**2)*DZ
C 402           CONTINUE
C            ELSE
C               WRITE(15,9001)ZPTW(I),(UPTW0(IPTW),IPTW=1,NPTW),
C     &              ((FPTW0(IPTW)/SQRT(RNORM)),ZERO,IPTW=1,NPTW)
C            ENDIF
C 404     CONTINUE
C 350  CONTINUE
C      CLOSE(15)
C********************************************************************
      CALL ISTOP(INFO)
 400  OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: premature end of file 12'',
     &     '' in extractptw.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
      CALL ISTOP(INFO)
 9000 FORMAT(4E18.10E2)
 9001 FORMAT(4E18.10E2,3(E18.10E2,F4.1))
 9002 FORMAT(3E16.8E2,I6)
C     NOTE: format statements 9000 and 9001 are rewritten by 
C     extractptw_prepare.script, which is a script file created by
C     extractptw_prepare.f
      END
