C+    update_ptw_rfiles.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2013 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS 
C SOFTWARE WILL BE ERROR-FREE.
C  
C+    IF iwave>1, THIS PROGRAM IS RUN AFTER THE SUCCESSFUL DETECTION
C+    OF A PERIODIC TRAVELLING WAVE, TO GENERATE TWO AUTO r. FILES 
C+    THAT WILL ENABLE THE CONTINUATION TO CARRY ON UNTIL THE NEXT 
C+    OCCURRENCE OF THE REQUIRED CONTROL PARAMETER VALUE. THE FIRST 
C+    r. FILE HAS THE SOLE PURPOSE OF GETTING AWAY FROM THE REQUIRED 
C+    CONTROL PARAMETER VALUE, AND THE SECOND THEN DOES THE MAIN 
C+    CONTINUATION UNTIL THE REQUIRED CONTROL PARAMETER VALUE IS 
C+    REACHED AGAIN. 
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CALL GINFO(INFO)
C-----
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''REWRITING AUTO r FILES (update_ptw_rfiles.f)'')')
      CLOSE(66)
      CALL IOUT(INFO,'minor')
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
C-----
C     First read in the required value of pp
      OPEN(11,FILE='../temp_files/control_parameters.data'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)PPTRGT
      CLOSE(11)
C     Now read in the auto output file
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 600 I=1,12
         READ(12,*,END=103)
 600  CONTINUE
      PPOLD=PPTRGT
C     an arbitrary and irrelevant initial value
      PP=PPTRGT
C     an arbitrary and irrelevant initial value
      DO 601 I=1,3
         READ(12,*,END=103)IDUMMY,IPT,ITY,ILAB,PPNEW
         PPOOLD=PPOLD
         PPOLD=PP
         PP=PPNEW 
 601  CONTINUE
      DO 100 I=1,NMXPTW
         READ(12,*,END=101)IDUMMY,IPT,ITY,ILAB,PPNEW
         PPOOLD=PPOLD
         PPOLD=PP
         PP=PPNEW 
 100  CONTINUE
C-----
      CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: MAX NUMBER OF STEPS WAS'')')
      WRITE(66,'(''   REACHED WHILE TRACKING THE'')')
      WRITE(66,'(''   BRANCH OF WAVE SOLUTIONS.'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
C-----
 103  CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: FILE 12 HAS INSUFFICIENT OUTPUT'',
     &     ''       LINES in update_ptw_rfiles.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CLOSE(12)
      CALL ISTOP(INFO)
C-----
 101  CLOSE(12)
C     Now rewrte auto r files
      PRRWAY=PP+(PP-PPOOLD)
      PWWWAY=PPOOLD
      OPEN(15,FILE='../temp_files/update_ptw_rfiles.output'
     &,STATUS='NEW')
      WRITE(15,'(2E18.10E2)')PP,PRRWAY
      CLOSE(15)
C-----
      OPEN(20,FILE='../temp_files/r.ptw.22'
     &,STATUS='OLD')
      REWIND(20)
      OPEN(22,FILE='../ptwcalc/r.ptw.22'
     &,STATUS='NEW')
      OPEN(33,FILE='../ptwcalc/r.ptw.33'
     &,STATUS='NEW')
      READ(20,*)I1,I2,IRS,I4
      WRITE(33,'(I8,I2,I5,I2)')I1,I2,ILAB,I4
      WRITE(22,'(I8,I2,I5,I2)')I1,I2,(ILAB+1),I4
      READ(20,*)I1,I2,I3
      WRITE(33,'(3I3)')I1,I2,I3
      WRITE(22,'(3I3)')I1,I2,I3
      READ(20,*)I1,I2,I3,I4,I5,I6,I7,I8
      WRITE(33,'(I8,7I2)')I1,I2,I3,I4,I5,I6,I7,I8
      WRITE(22,'(I8,7I2)')I1,I2,I3,I4,I5,I6,I7,I8
      READ(20,*)I1,R1,R2,R3,R4
      WRITE(33,'(I8,4E16.8E2)')I1,R1,R2,R3,R4
      WRITE(22,'(I8,4E16.8E2)')I1,R1,R2,R3,R4
      READ(20,*)I1,I2,I3,I4,I5,I6,I7
      WRITE(33,'(I8,6I3)')I1,I2,I3,I4,I5,I6,I7
      WRITE(22,'(I8,6I3)')I1,I2,I3,I4,I5,I6,I7
      READ(20,*)R1,R2,R3
      WRITE(33,'(3E16.8E2)')R1,R2,R3
      WRITE(22,'(3E16.8E2)')R1,R2,R3
      READ(20,*)R1,R2,R3,I1
      WRITE(33,'(3E16.8E2,I3)')(ABS(R2)*R1/ABS(R1)),R2,R3,I1
      WRITE(22,'(3E16.8E2,I3)')R1,R2,R3,I1
C     NOTE: The value of |ds| is set to |dsmin| deliberately 
C           in file 33: it should only run for a few steps.
      CLOSE(20)
      WRITE(33,'(''1'',/,''11 0.'',/,''0'',/,''2'')')
      WRITE(22,'(''1'',/,''11 0.'',/,''0'',/,''1'')')
      WRITE(33,'(''-1'',E16.8E2)')PRRWAY
      WRITE(33,'(''-1'',E16.8E2)')PWWWAY
      WRITE(22,'(''-1'',E16.8E2)')PPTRGT
      CLOSE(33)
      CLOSE(22)
C-----
      CALL ISTOP(INFO)
      END
